#include<bits/stdc++.h>
#include "shoes.h"
#define lsb(x) (x)&(-x)
#define fr first
#define sc second
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define ll long long
using namespace std;

void erase(vector<int> &v, int x){
    vector<int> nw;
    for(auto y : v){
        if(y == x) continue;
        nw.pb(y);
    }
    v = nw;
}

int solve(vector<int> &v, int x){
    erase(v, x);
    int l = 0, r = v.size() - 1;
    while(l < r){
        int m = (l + r) / 2;
        vector<int> tmp;
        tmp.pb(x); for(int i = l; i <= m; i ++) tmp.pb(v[i]);
        if(pairInSet(tmp)){
            r = m;
        }
        else{
            l = m + 1;
        }
    }
    return v[l];
}

std::vector<std::pair<int, int>> guessPairs(int n){
    vector<pair<int, int>> ans;
    /**
    vector<int> range = {1};
    for(int i = 2; i <= 2 * n; i ++){
        range.pb(i);
        if(pairInSet(range)){
            int company = solve(range, i);
            erase(range, company);
            ans.pb({i, company});
        }
    }
    */
    vector<int> used(2 * n + 1);
    while(ans.size() != n){
        int l = 2, r = 2 * n, bin_ans = -1;
        while(l <= r){
            int m = (l + r) / 2;
            vector<int> tmp;
            for(int i = 1; i <= m; i ++){
                if(!used[i]){
                    tmp.pb(i);
                }
            }
            if(pairInSet(tmp)){
                bin_ans = m;
                r = m - 1;
            }
            else{
                l = m + 1;
            }
        }
        vector<int> range;
        for(int i = 1; i <= bin_ans; i ++){
            if(!used[i]){
                range.pb(i);
            }
        }
        int company = solve(range, bin_ans);
        used[bin_ans] = used[company] = true;
        ans.pb({bin_ans, company});
    }
    return ans;
}


/**

*/
