#include<bits/stdc++.h>
#define lsb(x) (x)&(-x)
#define fr first
#define sc second
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define ll long long
using namespace std;

const int MAXN = 5e2 + 2;

int A[MAXN][MAXN], T = 1;
int n, m, h, w;

void rec(int x, int y, int c){
    if(A[x][y] != 0) return;
    if(x < 0 || x >= n || y < 0 || y >= m) return;
    A[x][y] = c;
    rec(x - 1, y, c);
    rec(x + 1, y, c);
    rec(x, y - 1, c);
    rec(x, y + 1, c);
}

int main(){
    cin >> n >> m >> h >> w;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            char c; cin >> c;
            if(c == '.') A[i][j] = -1;
            else         A[i][j] = 0;
        }
    }
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if(A[i][j] == 0){
                rec(i, j, T ++);
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i ++){
        vector<int> cnt(T, 0);
        int curr = 0;
        for(int j = 0; j < w; j ++){
            for(int ii = 0; ii < h; ii ++){
                if(A[i + ii][j] > 0){
                    if(cnt[A[i + ii][j]] == 0){
                        ++ curr;
                    }
                    cnt[A[i + ii][j]] ++;
                }
            }
        }
        for(int rem = 0, add = w; add < n; ++ rem, ++ add){
            for(int ii = 0; ii < h; ii ++){
                if(A[i + ii][rem] > 0){
                    if(cnt[A[i + ii][rem]] == 1){
                        -- curr;
                    }
                    cnt[A[i + ii][rem]] --;
                }
            }
            for(int ii = 0; ii < h; ii ++){
                if(A[i + ii][add] > 0){
                    if(cnt[A[i + ii][add]] == 0){
                        ++ curr;
                    }
                    cnt[A[i + ii][add]] ++;
                }
            }
            ans = max(ans, curr);
        }
    }
    cout << ans << endl;
}
/**
10 12 4 5
. x x . . x . . x x x .
. x . . x x . . . x x x
x x x . . x x x x . . .
. . x x . . . . . . x x
x . . x x x x . . . x x
x x . x . . x x . x x .
. x . . x x . x x . x .
. . x . . x x . . x x .
x x x . . . x x x x . .
. x . . x x . . . x . x
4
*/
