#include<iostream>
using namespace std;

int maxY;
int maxX;

int visochina;
int shirochina;

char pustinq[3010][3010];

int broiCvetove;
int kakvoImaTam[3010][3010];

void dfsOcvetqvane(int y, int x, int cvqt){
    //cout<<y<<" "<<x<<" "<<pustinq[y][x]<<endl;

    if(pustinq[y][x] == '.' || kakvoImaTam[y][x] != 0){
        return ;
    }

    kakvoImaTam[y][x] = cvqt;

    if(x > 0){
        dfsOcvetqvane(y, x - 1, cvqt);
    }
    if(y > 0){
        dfsOcvetqvane(y - 1, x, cvqt);
    }
    if(x < maxX - 1){
        dfsOcvetqvane(y, x + 1, cvqt);
    }
    if(y < maxY - 1){
        dfsOcvetqvane(y + 1, x, cvqt);
    }
}

bool toziCvqtImameLi[10000];

int kolkoRazlichni(int lqvX,int desenX, int gorenY, int dolenY){
    toziCvqtImameLi[0] = true;
    for(int i = 1; i <= broiCvetove; i++){
        toziCvqtImameLi[i] = false;
    }

    int broiche = 0;

    for(int y = dolenY; y <= gorenY; y++){
        for(int x = lqvX; x <= desenX; x++){
            if(toziCvqtImameLi[kakvoImaTam[y][x]] == false){
                toziCvqtImameLi[kakvoImaTam[y][x]] = true;
                broiche++;
            }
        }
    }

    return broiche++;
}

int main(){

    cin>>maxY>>maxX>>visochina>>shirochina;

    for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            cin>>pustinq[y][x];
        }
    }

    for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            if(pustinq[y][x] == 'x' && kakvoImaTam[y][x] == 0){
                broiCvetove++;
                dfsOcvetqvane(y, x, broiCvetove);
            }
        }
    }

    /*for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            cout<<kakvoImaTam[y][x]<<" ";
        }
        cout<<endl;
    }*/

    int maxPlemena = 0;

    for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            int tuka = kolkoRazlichni(x, x + shirochina - 1, y + visochina - 1, y);

            maxPlemena = max(maxPlemena, tuka);
        }
    }

    cout<<maxPlemena<<endl;

    return 0;
}
