#include<iostream>
using namespace std;

int maxY;
int maxX;

int visochina;
int shirochina;

char pustinq[3010][3010];

int broiXoveDo[3010][3010];

int broiCvetove;
int kakvoImaTam[3010][3010];

void dfsOcvetqvane(int y, int x, int cvqt){
    //cout<<y<<" "<<x<<" "<<pustinq[y][x]<<endl;

    if(pustinq[y][x] == '.' || kakvoImaTam[y][x] != 0){
        return ;
    }

    kakvoImaTam[y][x] = cvqt;

    if(x > 0){
        dfsOcvetqvane(y, x - 1, cvqt);
    }
    if(y > 0){
        dfsOcvetqvane(y - 1, x, cvqt);
    }
    if(x < maxX - 1){
        dfsOcvetqvane(y, x + 1, cvqt);
    }
    if(y < maxY - 1){
        dfsOcvetqvane(y + 1, x, cvqt);
    }
}

bool toziCvqtImameLi[10000];

int kolkoRazlichni(int lqvX,int desenX, int gorenY, int dolenY){
    toziCvqtImameLi[0] = true;
    for(int i = 1; i <= broiCvetove; i++){
        toziCvqtImameLi[i] = false;
    }

    int broiche = 0;

    for(int y = dolenY; y <= gorenY; y++){
        for(int x = lqvX; x <= desenX; x++){
            if(toziCvqtImameLi[kakvoImaTam[y][x]] == false){
                toziCvqtImameLi[kakvoImaTam[y][x]] = true;
                broiche++;
            }
        }
    }

    return broiche++;
}

int main(){

    cin>>maxY>>maxX>>visochina>>shirochina;

    for(int y = 1; y <= maxY; y++){
        for(int x = 1; x <= maxX; x++){
            cin>>pustinq[y][x];
        }
    }

    for(int y = 1; y <= maxY; y++){
        for(int x = 1; x <= maxX; x++){
            broiXoveDo[y][x] = broiXoveDo[y - 1][x] + broiXoveDo[y][x - 1] - broiXoveDo[y - 1][x - 1];

            if(pustinq[y][x] == 'x'){
                broiXoveDo[y][x]++;
            }
        }
    }

    int maxPlemena = 0;

    for(int y = visochina; y <= maxY; y++){
        for(int x = shirochina; x <= maxX; x++){
            int tuka = broiXoveDo[y][x] - broiXoveDo[y-visochina][x] - broiXoveDo[y][x-shirochina] + broiXoveDo[y-visochina-1][x-visochina-1];

            maxPlemena = max(maxPlemena, tuka);
        }
    }

    /*for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            if(pustinq[y][x] == 'x' && kakvoImaTam[y][x] == 0){
                broiCvetove++;
                dfsOcvetqvane(y, x, broiCvetove);
            }
        }
    }

    int maxPlemena = 0;

    for(int y = 0; y < maxY; y++){
        for(int x = 0; x < maxX; x++){
            int tuka = kolkoRazlichni(x, x + shirochina - 1, y + visochina - 1, y);

            maxPlemena = max(maxPlemena, tuka);
        }
    }*/

    cout<<maxPlemena<<endl;

    return 0;
}
