#include<bits/stdc++.h>
using namespace std;
const int MAXN=3006;
struct BIT
{
    int t[MAXN];
    void update1(int idx,int val)
    {
        idx++;
        for(;idx<MAXN;idx+=idx&(-idx))
        {
            t[idx]+=val;
        }
    }
    void update(int l,int r,int val)
    {
        update1(r+1,-val);
        update1(l,+val);
    }
    int query(int idx)
    {
        idx++;
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=t[idx];
        }
        return ret;
    }
}fen[MAXN];
int n,m,h,w;
bool t[MAXN][MAXN];
bool vis[MAXN][MAXN];
int dx[4]={1,-1,0,0};
int dy[4]={0,0,-1,1};
vector<pair<int,int> >comp;
void dfs(int x,int y)
{
    vis[x][y]=1;
    comp.push_back({x,y});
    for(int l=0;l<4;l++)
    {
        int x1=x+dx[l];
        int y1=y+dy[l];
        if(x1<1||y1<1)continue;
        if(x1>n||y1>m)continue;
        if(vis[x1][y1])continue;
        if(!t[x1][y1])continue;
        dfs(x1,y1);
    }
}
int calc_t[MAXN][MAXN];
int main()
{
    cin>>n>>m>>h>>w;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            char c;
            cin>>c;
            if(c!='.')t[i][j]=1;
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!t[i][j])continue;
            if(vis[i][j])continue;
            comp.clear();
            dfs(i,j);
            int t=comp.size();
            //cout<<"comp\n";
            for(int f=0;f<t;f++)
            {
                //cout<<comp[f].first<<" "<<comp[f].second<<endl;
                comp.push_back({max(1,comp[f].first-h+1),max(1,comp[f].second-w+1)});
                comp.push_back({max(1,comp[f].first-h+1),comp[f].second});
                comp.push_back({comp[f].first,max(1,comp[f].second-w+1)});
            }
            sort(comp.begin(),comp.end());
            vector<pair<int,int> >left_env,right_env;
            for(int f=0;f<comp.size();f++)
            {
                if(f==0||comp[f].first!=comp[f-1].first)
                {
                    left_env.push_back(comp[f]);
                }
                if(f==comp.size()-1||comp[f].first!=comp[f+1].first)
                {
                    right_env.push_back(comp[f]);
                }
            }
            /*cout<<"left_env\n";
            for(auto xd:left_env)cout<<xd.first<<" "<<xd.second<<endl;
            cout<<"right_env\n";
            for(auto xd:right_env)cout<<xd.first<<" "<<xd.second<<endl;*/
            for(int f=0;f<left_env.size();f++)
            {
                fen[left_env[f].second].update(left_env[f].first,left_env[f].first,+1);
                if(f==0)continue;
                if(left_env[f].first==left_env[f-1].first+1)continue;
                int maxy=max(left_env[f].second,left_env[f-1].second);
                fen[maxy].update(left_env[f-1].first+1,left_env[f].first-1,+1);
            }
            for(int f=0;f<right_env.size();f++)
            {
                fen[right_env[f].second+1].update(right_env[f].first,right_env[f].first,-1);
                if(f==0)continue;
                if(right_env[f].first==right_env[f-1].first+1)continue;
                int miny=min(right_env[f].second,right_env[f-1].second);
                fen[miny].update(right_env[f-1].first+1,right_env[f].first-1,-1);
            }
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            calc_t[i][j]=fen[j].query(i);
        }
    }
    int ans=0;
    for(int i=1;i<=n;i++)
    {
        int cur=0;
        for(int j=1;j<=m;j++)
        {
            cur+=calc_t[i][j];
            ans=max(ans,cur);
        }
    }
    cout<<ans<<endl;
return 0;
}
/*
5 5 1 1
.....
..x..
.xxx.
..x..
.....
*/
