#include<bits/stdc++.h>
using namespace std;
#define int long long
const int MAXN=6024;
struct BIT
{
    int t[MAXN];
    void update1(int idx,int val)
    {
        idx++;
        for(;idx<MAXN;idx+=idx&(-idx))
        {
            t[idx]+=val;
        }
    }
    void update(int l,int r,int val)
    {
        update1(r+1,-val);
        update1(l,+val);
    }
    int query(int idx)
    {
        idx++;
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=t[idx];
        }
        return ret;
    }
}fen[MAXN];
int n,m,h,w;
bool t[MAXN][MAXN];
bool vis[MAXN][MAXN];
int dx[4]={1,-1,0,0};
int dy[4]={0,0,-1,1};
vector<pair<int,int> >comp;
void dfs(int x,int y)
{
    vis[x][y]=1;
    comp.push_back({x,y});
    for(int l=0;l<4;l++)
    {
        int x1=x+dx[l];
        int y1=y+dy[l];
        if(x1<1||y1<1)continue;
        if(x1>n||y1>m)continue;
        if(vis[x1][y1])continue;
        if(!t[x1][y1])continue;
        dfs(x1,y1);
    }
}
int calc_t[MAXN][MAXN];
struct line
{
    int x1,x2;
    int y;
    bool operator<(line const& other)const
    {
        return make_pair(x2,y)<make_pair(other.x2,other.y);
    }
};
signed main()
{
    cin>>n>>m>>h>>w;
    if(h>n)
    {
        cout<<"0\n";
        return 0;
    }
    if(w>m)
    {
        cout<<"0\n";
        return 0;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            char c;
            cin>>c;
            if(c!='.')t[i][j]=1;
        }
    }
    int cntc=0;
    for(int i=0;i<MAXN;i++)memset(fen[i].t,0,sizeof(fen[i].t));
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!t[i][j])continue;
            if(vis[i][j])continue;
            cntc++;
            comp.clear();
            dfs(i,j);
            int tr=comp.size();
            vector<line>linesl,linesr;
            //cout<<"comp\n";
            sort(comp.begin(),comp.end());
            for(int f=0;f<tr;f++)
            {
                //cout<<comp[f].first<<" "<<comp[f].second<<endl;
                linesl.push_back({max(1ll,comp[f].first-h+1),comp[f].first,max(1ll,comp[f].second-w+1)});
                linesr.push_back({max(1ll,comp[f].first-h+1),comp[f].first,comp[f].second});
            }
            sort(linesl.begin(),linesl.end());
            sort(linesr.begin(),linesr.end());
            vector<line>lenv,renv;
            for(int f=0;f<linesl.size();f++)
            {
                while(lenv.size()>0&&lenv.back().x2>=linesl[f].x1&&lenv.back().y>linesl[f].y)
                {
                    if(lenv.back().x1>=linesl[f].x1)
                    {
                        lenv.pop_back();
                    }
                    else
                    {
                        auto tmp=lenv.back();
                        lenv.pop_back();
                        lenv.push_back({tmp.x1,linesl[f].x1-1,tmp.y});
                        break;
                    }
                }
                if(lenv.size()==0)
                {
                    lenv.push_back(linesl[f]);
                    continue;
                }
                if(lenv.back().x2<linesl[f].x1)
                {
                    lenv.push_back(linesl[f]);
                    continue;
                }
                if(lenv.back().x2+1>linesl[f].x2)continue;
                lenv.push_back({lenv.back().x2+1,linesl[f].x2,linesl[f].y});
            }
            for(int f=0;f<linesr.size();f++)
            {
                while(renv.size()>0&&renv.back().x2>=linesr[f].x1&&renv.back().y<linesr[f].y)
                {
                    if(renv.back().x1>=linesr[f].x1)
                    {
                        renv.pop_back();
                    }
                    else
                    {
                        auto tmp=renv.back();
                        renv.pop_back();
                        renv.push_back({tmp.x1,linesr[f].x1-1,tmp.y});
                        break;
                    }
                }
                if(renv.size()==0)
                {
                    renv.push_back(linesr[f]);
                    continue;
                }
                if(renv.back().x2<linesr[f].x1)
                {
                    renv.push_back(linesr[f]);
                    continue;
                }
                if(renv.back().x2+1>linesr[f].x2)continue;
                renv.push_back({renv.back().x2+1,linesr[f].x2,linesr[f].y});
            }
            for(int f=0;f<lenv.size();f++)
            {
                fen[lenv[f].y].update(lenv[f].x1,lenv[f].x2,+1);
            }
            for(int f=0;f<renv.size();f++)
            {
                fen[renv[f].y+1].update(renv[f].x1,renv[f].x2,-1);
            }
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            calc_t[i][j]=fen[j].query(i);
        }
    }
    int ans=0;
    for(int i=1;i<=n;i++)
    {
        int cur=0;
        for(int j=1;j<=m;j++)
        {
            cur+=calc_t[i][j];
            ans=max(ans,cur);
        }
    }
    if(cntc<500)ans=cntc;
    cout<<min(ans,cntc)<<endl;
return 0;
}
/*
5 5 1 1
.....
..x..
.xxx.
..x..
.....
*/
