#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42,inf=1e9+42;

int n;
pair<int,int> inp[nmax];

bool check(int p,int q)
{
    int x1=min(inp[p].first,inp[q].first);
    int y1=min(inp[p].second,inp[q].second);

    int x2=max(inp[p].first,inp[q].first);
    int y2=max(inp[p].second,inp[q].second);

    int cnt=0;

    for(int i=1;i<=n&&cnt<=2;i++)
        if(x1<=inp[i].first&&inp[i].first<=x2&&y1<=inp[i].second&&inp[i].second<=y2)cnt++;

    return cnt==2;
}

int slow()
{
    int ret=0;

    for(int i=1;i<=n;i++)
        for(int j=i+1;j<=n;j++)
            ret+=check(i,j);

    return ret;
}

mt19937 rng(42);

int main()
{
    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i%i",&inp[i].first,&inp[i].second);


    {

    /*
    n=10;
    for(int i=1;i<=n;i++)
    {
        inp[i].first=rng()%5;
        inp[i].second=rng()%5;

        bool seen=0;

        for(int j=1;j<i;j++)
            if(inp[i]==inp[j])seen=1;

        if(seen)i--;
    }
    */

    inp[0]={-inf-1,-inf-1};

    sort(inp+1,inp+n+1);

    int outp=0;

    for(int i=1;i<=n;i++)
    {
        int at_least=-inf;
        int at_most=inf;

        if(i>=2&&inp[i-1].first==inp[i].first)
        {
            at_least=inp[i-1].second+1;
            outp++;
        }
        if(i<n&&inp[i].first==inp[i+1].first)
        {
            at_most=inp[i+1].second-1;
        }

        for(int j=i-1;j>=1;j--)
        {
            if(inp[i].second==inp[j].second)
            {
                outp++;
                break;
            }

            if(at_least<=inp[j].second&&inp[j].second<=inp[i].second)
            {
                //cout<<"ok "<<i<<" "<<j<<endl;

                outp++;
                at_least=inp[j].second+1;
            }

            if(inp[j].second<=at_most&&inp[j].second>inp[i].second&&(inp[j-1].first!=inp[j].first||inp[j-1].second<inp[i].second))
            {
                //cout<<"ok "<<i<<" "<<j<<endl;

                outp++;
                at_most=inp[j].second-1;
            }
        }
    }

    /*
    cout<<outp<<" "<<slow()<<endl;

    for(int i=1;i<=n;i++)
        cout<<inp[i].first<<" "<<inp[i].second<<endl;

    assert(outp==slow());
    */

    printf("%i\n",outp);
    }

    return 0;
}
