#include<bits/stdc++.h>
using namespace std;

const int nmax=3e5+42,inf=1e9+42;

int n;
pair<int,int> inp[nmax];

bool check(int p,int q)
{
    int x1=min(inp[p].first,inp[q].first);
    int y1=min(inp[p].second,inp[q].second);

    int x2=max(inp[p].first,inp[q].first);
    int y2=max(inp[p].second,inp[q].second);

    int cnt=0;

    for(int i=1;i<=n&&cnt<=2;i++)
        if(x1<=inp[i].first&&inp[i].first<=x2&&y1<=inp[i].second&&inp[i].second<=y2)cnt++;

    return cnt==2;
}

int slow()
{
    int ret=0;

    for(int i=1;i<=n;i++)
        for(int j=i+1;j<=n;j++)
            ret+=check(i,j);

    return ret;
}

mt19937 rng(42);

int nxt[nmax];
int start[nmax];

stack<int> st,idle;

long long eval()//no equal
{
    for(int i=1;i<=n;i++)nxt[i]=n+1,start[i]=n+1;

    inp[0]={-inf-1,-inf-1};

    sort(inp+1,inp+n+1);

    st=idle;

    for(int i=1;i<=n;i++)
    {
        while(st.size()&&inp[st.top()].second>inp[i].second)
        {
            nxt[st.top()]=i;
            st.pop();
        }

        if(st.size())start[i]=st.top();

        st.push(i);
    }

    long long outp=0;

    for(int i=1;i<=n;i++)
    {
        int j=start[i];

        while(j<i)
        {
            outp++;
            j=start[j];
        }
    }

    return outp;
}

long long fast()
{
    long long outp=0;

    map<int,int> cnt_x={},cnt_y={};

    for(int i=1;i<=n;i++)
    {
        cnt_x[inp[i].first]++;
        cnt_y[inp[i].second]++;
    }

    for(auto w:cnt_x)
        outp+=w.second-1;

    for(auto w:cnt_y)
        outp+=w.second-1;

    outp+=eval();

    for(int i=1;i<=n;i++)
        inp[i].second=-inp[i].second;

    outp+=eval();

    return outp;
}

void gen()
{
    n=10;
    for(int i=1;i<=n;i++)
    {
        inp[i].first=rng()%5;
        inp[i].second=rng()%5;

        bool seen=0;

        for(int j=1;j<i;j++)
            if(inp[i]==inp[j])seen=1;

        if(seen)i--;
    }
}

int main()
{
    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i%i",&inp[i].first,&inp[i].second);

    //gen();

    printf("%lld\n",fast());

    return 0;
}
