#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 10000;

short a[MAXN + 5][MAXN + 5];
short dp[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector<int> vx, vy;
    vector< pair<int, int> > xy;
    for (int i = 1; i <= n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        xy.push_back(make_pair(x, y));
        vx.push_back(x);
        vy.push_back(y);
    }

    sort(vx.begin(), vx.end());
    auto itx = unique(vx.begin(), vx.end());
    vx.resize(distance(vx.begin(), itx));

    sort(vy.begin(), vy.end());
    auto ity = unique(vy.begin(), vy.end());
    vy.resize(distance(vy.begin(), ity));

    for (int i = 0; i < n; ++ i)
    {
        int px = lower_bound(vx.begin(), vx.end(), xy[i].first) - vx.begin();
        xy[i].first = px + 1;
        int py = lower_bound(vy.begin(), vy.end(), xy[i].second) - vy.begin();
        xy[i].second = py + 1;
        a[xy[i].first][xy[i].second] = 1;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            dp[i][j] = dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1] + a[i][j];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = i + 1; j < n; ++ j)
        {
            int x1 = min(xy[i].first, xy[j].first), x2 = max(xy[i].first, xy[j].first);
            int y1 = min(xy[i].second, xy[j].second), y2 = max(xy[i].second, xy[j].second);
            short t = dp[x2][y2] - dp[x1 - 1][y2] - dp[x2][y1 - 1] + dp[x1 - 1][y1 - 1];
            if (t == 2) ans++;
        }
    }

    cout << ans << endl;

    return 0;
}
