#include <iostream>
#include <utility>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 3000;

int cnt = 0;
int vis[MAXN * MAXN + 5];
int a[MAXN + 5][MAXN + 5];
bool t[MAXN + 5][MAXN + 5], used[MAXN + 5][MAXN + 5];

void BFS(int i, int j)
{
    cnt++;
    queue< pair<int, int> > q;
    q.push({i, j});
    while (!q.empty())
    {
        i = q.front().first;
        j = q.front().second;
        a[i][j] = cnt;
        q.pop();

        if (t[i - 1][j] and !used[i - 1][j])
        {
            q.push({i - 1, j});
            used[i - 1][j] = true;
        }
        if (t[i][j - 1] and !used[i][j - 1])
        {
            q.push({i, j - 1});
            used[i][j - 1] = true;
        }
        if (t[i][j + 1] and !used[i][j + 1])
        {
            q.push({i, j + 1});
            used[i][j + 1] = true;
        }
        if (t[i + 1][j] and !used[i + 1][j])
        {
            q.push({i + 1, j});
            used[i + 1][j] = true;
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, h, w;
    cin >> n >> m >> h >> w;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char c;
            cin >> c;

            if (c == 'x') t[i][j] = true;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            if (t[i][j] and !used[i][j]) BFS(i, j);
        }
    }

    int c = 0;
    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            if (i + h - 1 <= n and j + w - 1 <= m)
            {
                c++;
                int cnt = 0;
                for (int i1 = i; i1 < i + h; ++ i1)
                {
                    for (int j1 = j; j1 < j + w; ++ j1)
                    {
                        if (vis[a[i1][j1]] != c)
                        {
                            vis[a[i1][j1]] = c;
                            if (a[i1][j1]) cnt++;
                        }
                    }
                }
                ans = max(ans, cnt);
            }
        }
    }

    cout << ans << endl;

    return 0;
}
