#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

const int maxn = 3e5+5;

int n;
pair <int, int> points [maxn];
long long ans;

vector <pair <int, int> > solve (int lidx, int ridx, bool isleft){
    if (points [lidx].x == points [ridx].x){
        ans += ridx - lidx;
        vector <pair <int, int> > v;
        for (int i = lidx; i <= ridx; i ++) v.push_back (points [i]);
        return v;
    }

    int midx = lidx + ridx >> 1;
    while (points [midx].x == points [midx + 1].x){
        if (points [midx].x == points [ridx].x) midx --;
        else midx ++;
    }
    vector <pair <int, int> >  l = solve (lidx, midx, 1), r = solve (midx + 1, ridx, 0), merged;
    int szl = l.size (), szr = r.size ();

    vector <pair <int, int> > vl, vr;
    int il = 0, ir = 0;
    while (il < szl || ir < szr){
        if (il < szl && ir < szr && l [il].y == r [ir].y){
            pair <int, int> upl = make_pair (l [il].y, l [il].x);
            while (!vl.empty () && vl.back ().y <= l [il].x){
                if (vl.back ().y == l [il].x && upl == make_pair (l [il].y, l [il].x)) upl.x = vl.back ().x;
                vl.pop_back ();
            }
            if (!vl.empty () && upl == make_pair (l [il].y, l [il].x)) upl = vl.back ();
            pair <int, int> upr = make_pair (r [ir].y, r [ir].x);
            while (!vr.empty () && vr.back ().y >= r [ir].x){
                if (vr.back ().y == r [ir].x && upr == make_pair (r [ir].y, r [ir].x)) upr.x = vr.back ().x;
                vr.pop_back ();
            }
            if (!vr.empty () && upr == make_pair (r [ir].y, r [ir].x)) upr = vr.back ();
            ans += vr.size ();
            if (upl != make_pair (l [il].y, l [il].x)) ans -= upper_bound (vr.begin (), vr.end (), make_pair (upl.x + 1, upl.y)) - vr.begin ();
            vl.push_back ({l [il].y, l [il].x});
            ans += vl.size ();
            if (upr != make_pair (r [ir].y, r [ir].x)) ans -= upper_bound (vl.begin (), vl.end (), upr) - vl.begin ();
            vr.push_back ({r [ir].y, r [ir].x});
            if (isleft) merged.push_back(r [ir]);
            else merged.push_back (l [il]);
            il ++;
            ir ++;
        }
        else if (ir == szr || il < szl && l [il].y < r [ir].y){
            pair <int, int> up = make_pair (l [il].y, l [il].x);
            while (!vl.empty () && vl.back ().y <= l [il].x){
                if (vl.back ().y == l [il].x && up == make_pair (l [il].y, l [il].x)) up.x = vl.back ().x;
                vl.pop_back ();
            }
            if (!vl.empty () && up == make_pair (l [il].y, l [il].x)) up = vl.back ();
            ans += vr.size ();
            if (up != make_pair (l [il].y, l [il].x)) ans -= upper_bound (vr.begin (), vr.end (), make_pair (up.x + 1, up.y)) - vr.begin ();
            vl.push_back ({l [il].y, l [il].x});
            merged.push_back (l [il]);
            il ++;
        }
        else{
            pair <int, int> up = make_pair (r [ir].y, r [ir].x);
            while (!vr.empty () && vr.back ().y >= r [ir].x){
                if (vr.back ().y == r [ir].x && up == make_pair (r [ir].y, r [ir].x)) up.x = vr.back ().x;
                vr.pop_back ();
            }
            if (!vr.empty () && up == make_pair (r [ir].y, r [ir].x)) up = vr.back ();
            ans += vl.size ();
            if (up != make_pair (r [ir].y, r [ir].x)) ans -= upper_bound (vl.begin (), vl.end (), up) - vl.begin ();
            vr.push_back ({r [ir].y, r [ir].x});
            merged.push_back (r [ir]);
            ir ++;
        }
    }

    return merged;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++) cin >> points [i].x >> points [i].y;
    sort (points, points + n);
    solve (0, n - 1, 1);
    cout << ans << '\n';

}