#include <bits/stdc++.h>
using namespace std;

const int maxn = 3003, maxk = 20;
int n, m, h, w;
int a [maxn][maxn];
int k;
int cnt1 [maxn][maxn][maxk], cnt2 [maxn][maxn][maxk];
int ans;

void bfs (int i, int j){

    k ++;
    queue <pair <int, int> > q;
    q.push ({i, j});
    while (!q.empty ()){
        auto p = q.front ();
        q.pop ();
        i = p.first;
        j = p.second;
        if (i < 0 || i == n || j < 0 || j == m || a [i][j] != -1) continue;
        a [i][j] = k;
        q.push ({i, j - 1});
        q.push ({i, j + 1});
        q.push ({i - 1, j});
        q.push ({i + 1, j});
    }

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> h >> w;
    for (int i = 0; i < n; i ++){
        for (int j = 0; j < m; j ++){
            char ch;
            cin >> ch;
            if (ch == 'x') a [i][j] = -1;
        }
    }
    for (int i = 0; i < n; i ++){
        for (int j = 0; j < m; j ++){
            if (a [i][j] == -1) bfs (i, j);
        }
    }

    for (int i = 0; i < n; i ++){
        for (int j = 0; j < w; j ++) cnt1 [i][w - 1][a [i][j]] ++;
        for (int j = w; j < n; j ++){
            for (int x = 1; x <= k; x ++) cnt1 [i][j][x] = cnt1 [i][j - 1][x];
            cnt1 [i][j][a [i][j - w]] --;
            cnt1 [i][j][a [i][j]] ++;
        }
    }

    for (int j = w - 1; j < m; j ++){
        for (int i = 0; i < h; i ++){
            for (int x = 1; x <= k; x ++) cnt2 [h - 1][j][x] += cnt1 [i][j][x];
        }
        for (int i = h; i < n; i ++){
            for (int x = 1; x <= k; x ++) cnt2 [i][j][x] = cnt2 [i - 1][j][x] - cnt1 [i - h][j][x] + cnt1 [i][j][x];
        }
    }

    for (int i = h - 1; i < n; i ++){
        for (int j = w - 1; j < m; j ++){
            int curr = 0;
            for (int x = 1; x <= k; x ++) curr += min (1, cnt2 [i][j][x]);
            ans = max (ans, curr);
        }
    }

    // for (int i = h - 1; i < n; i ++){
    //     for (int j = w - 1; j < m; j ++){
    //         for (int ii = 0; ii < h; ii ++){
    //             for (int jj = 0; jj < w; jj ++){
    //                 cnt [a [i - ii][j - jj]] = 1;
    //             }
    //         }
    //         int curr = 0;
    //         for (int x = 1; x <= k; x ++){
    //             curr += cnt [x];
    //             cnt [x] = 0;
    //         }
    //         ans = max (ans, curr);
    //     }
    // }

    cout << ans << '\n';

}