#include <bits/stdc++.h>
#include "shoes.h"

using namespace std;

pair <int, int> find_a_pair(vector <int> v) {
    if ((int)v.size() == 2)
    return make_pair(v[0], v[1]);

    for (;;) {
        vector <int> v1, v2;
        for (int i = 0; i < (int)v.size(); i++) {
            if (rand() & 1)
                v1.push_back(v[i]);

            else
                v2.push_back(v[i]);
        }

        if (pairInSet(v1))
            return find_a_pair(v1);

        if (pairInSet(v2))
            return find_a_pair(v2);
    }
}

vector<std::pair<int, int>> guessPairs(int n) {
    vector <pair <int, int> > ans;
    set <int> s;
    for (int i = n+1; i <= 2 * n; i++)
        s.insert(i);

    for (int i = 1; i <= n; i++) {
        vector <int> lft(s.begin(), s.end());
        int low = 0, high = (int)lft.size() - 1;
        while (low < high) {
            int mid = (low + high) / 2;
            vector <int> to_test;
            for (int j = 0; j <= mid; j++)
            to_test.push_back(lft[j]);

            to_test.push_back(i);
            if (pairInSet(to_test))
                high = mid;

            else
                low = mid + 1;
        }

        ans.push_back(make_pair(i, lft[low]));
        s.erase(lft[low]);
    }

    return ans;
}
