#include <bits/stdc++.h>
#include "shoes.h"

using namespace std;

vector <int> v;
vector <pair <int, int> > ans;

void find_a_pair(int l, int r) {
    for (int i = l + 1; i <= r; i++) {
        vector <int> temp;
        temp.push_back(v[l]);
        temp.push_back(v[i]);

        if (pairInSet(temp)) {
            ans.push_back(make_pair(v[l], v[i]));
            v.erase(v.begin() + i);
            v.erase(v.begin() + l);

            break;
        }
    }
}

void find_pair(int l, int r) {
    if (r - l + 1 <= 50) {
        find_a_pair(l, r);
        return;
    }

    int mid = (l + r) / 2;
    for (int i = 1; i <= 4; i++) {
        random_shuffle(v.begin() + l, v.begin() + r + 1);
        vector <int> temp;
        for (int i = l; i <= mid; i++)
            temp.push_back(v[i]);

        if (pairInSet(temp)) {
            find_pair(l, mid);
            break;
        }

        temp.clear();
        for (int i = mid + 1; i <= r; i++)
            temp.push_back(v[i]);

        if (pairInSet(temp)) {
            find_pair(mid + 1, r);
            break;
        }
    }
}



vector<std::pair<int, int>> guessPairs(int n) {
    ans.clear();
    v.clear();

    for (int i = 1; i <= 2 * n; i++)
        v.push_back(i);

    while ((int)v.size() >= 500)
        find_pair(0, (int)v.size()-1);

    while (!v.empty())
        find_a_pair(0, (int)v.size()-1);

    return ans;
}
