#include "shoes.h"

#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " = " << x << " ]"

struct debug {
    debug() { cerr << "Debugger start " << endl; }
    ~debug() { cerr << endl << "Debugger end " << endl; }

    template<class T>
    debug& operator <<(const T &x) {
        cerr << x;
        return (*this);
    }
};

template<class T> inline ostream &operator <<(ostream &out, const vector<T> &x) {
    for(auto it : x) {
        out << it << " ";
    }
    return out;
}

template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T, class T2> bool chkmin(T &x, const T2 &y) {
    return (x > y) ? x = y, true : false;
}
template<class T, class T2> bool chkmax(T &x, const T2 &y) {
    return (x < y) ? x = y, true : false;
}
typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void rem(vector<int> &arr, int x) {
    for(int i = 0; i < arr.size(); i ++) {
        if(arr[i] == x) {
            swap(arr[i], arr[arr.size() - 1]);
        }
    }
    arr.pop_back();
}

int findPair(int x, vector<int> &rght) {
    auto eval = [&](int m) {
        vector<int> toAsk = {};
        toAsk.push_back(x);
        for(int i = 0; i < m; i ++) {
            toAsk.push_back(rght[i]);
        }
        return pairInSet(toAsk);
    };

    int l = 0, r = rght.size();
    while(l < r - 1) {
        int m = (l + r) / 2ll;
        if(eval(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    return rght[l];
}

std::vector<std::pair<int, int>> guessPairs(int n) {
    vector<pair<int, int> > ret;

    vector<int> sh;
    for(int i = 1; i <= 2 * n; i ++) {
        sh.push_back(i);
    }
    srand(time(NULL));
    random_shuffle(sh.begin(), sh.end());

    vector<int> lft, rght;

    for(int i : sh) {
        lft.push_back(i);
        if(lft.size() && (lft.size() + ret.size() > n || pairInSet(lft))) {
            lft.pop_back();
            rght.push_back(i);

            int now = findPair(i, lft);
            rem(lft, now);
            rem(rght, i);
            ret.push_back({i, now});
        } else {
            if(!rght.empty()) {
                int now = findPair(i, rght);
                rem(rght, now);
                rem(lft, i);
                ret.push_back({i, now});
            }
        }
    }

    return ret;
}
