#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

struct point{
    int x;
    int y;
};

int n,ans;
point p[MAXN];

bool cmp(point fr,point sc){
    return fr.x<sc.x;
}

vector<int> tree[4*MAXN];

void combine(int a,int b,int c){
    for(int i:tree[b])tree[a].push_back(i);
    for(int i:tree[c])tree[a].push_back(i);
    sort(tree[a].begin(),tree[a].end());
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={p[l].y};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        combine(v,2*v,2*v+1);
    }
}

int bin(int v,int from,int to){
    int l=-1,r=tree[v].size(),tt;
    while(l+1<r){
        tt=(l+r)/2;
        if(tree[v][tt]>=from){
            r=tt;
        }else{
            l=tt;
        }
    }
    int ll=-1,rr=tree[v].size();
    while(ll+1<rr){
        tt=(ll+rr)/2;
        if(tree[v][tt]<=to){
            ll=tt;
        }else{
            rr=tt;
        }
    }
    return ll-r+1;
}

int query(int v,int l,int r,int ll,int rr,int from,int to){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        return bin(v,from,to);
    }else{
        int tt=(l+r)/2;
        return query(2*v,l,tt,ll,min(tt,rr),from,to) + query(2*v+1,tt+1,r,max(tt+1,ll),rr,from,to);
    }
}

int binl(int x){
    int l=0,r=n+1,tt;
    while(l+1<r){
        tt=(l+r)/2;
        if(p[tt].x>=x){
            r=tt;
        }else{
            l=tt;
        }
    }
    return r;
}

int binr(int x){
    int l=0,r=n+1,tt;
    while(l+1<r){
        tt=(l+r)/2;
        if(p[tt].x<=x){
            l=tt;
        }else{
            r=tt;
        }
    }
    return l;
}

bool ok(int a,int b,int c,int d){
    if(a>c)swap(a,c);
    if(b>d)swap(b,d);
    int lb=binl(a),rb=binr(c);
    return query(1,1,n,lb,rb,b,d)==2;
}

int main(){

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>p[i].x>>p[i].y;
    }
    sort(p+1,p+n+1,cmp);
    build(1,1,n);

    for(int i=1;i<=n;i++){
        for(int f=i+1;f<=n;f++){
            if(ok(p[i].x,p[i].y,p[f].x,p[f].y))ans++;
        }
    }

    cout<<ans<<"\n";

    return 0;
}