#include<bits/stdc++.h>
using namespace std;

int n,m,w,h,k,a,b,curr,ans,pos;
char t[3007][3007];
int cnt[3007*3007];
int vis[3007][3007];
int row[3007][3007][21];
int col[3007][3007][21];

bool ok(int x,int y){
    return x>=1 and x<=n and y>=1 and y<=m and vis[x][y]==0 and t[x][y]=='x';
}

void dfs(int x,int y){
    vis[x][y]=k;
    if(ok(x-1,y))dfs(x-1,y);
    if(ok(x+1,y))dfs(x+1,y);
    if(ok(x,y-1))dfs(x,y-1);
    if(ok(x,y+1))dfs(x,y+1);
}

void add(int x,int y){
    if(x==0)return;
    cnt[x]+=y;
    if(cnt[x]==y and y>0)curr++;
}

void rem(int x,int y){
    if(x==0)return;
    cnt[x]-=y;
    if(cnt[x]==0 and y>0)curr--;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>h>>w;
    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            cin>>t[i][f];
        }
    }
    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            if(vis[i][f]==0 and t[i][f]=='x'){
                k++;dfs(i,f);
            }
        }
    }

    for(int i=1;i<=h;i++){
        for(int f=1;f<=w;f++){
            add(vis[i][f],1);
        }
    }
    ans=max(ans,curr);

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            row[i][f][vis[i][f]]++;
            col[i][f][vis[i][f]]++;
            for(int s=1;s<=20;s++){
                row[i][f][s]+=row[i][f-1][s];
                col[i][f][s]+=col[i-1][f][s];
            }
        }
    }

    a=b=1;
    while(true){
        if(pos==0){
            if(b<m-w+1){
                b++;
                for(int i=1;i<=20;i++){
                    rem(i,col[a+h-1][b-1][i]-col[a-1][b-1][i]);
                }
                for(int i=1;i<=20;i++){
                    add(i,col[a+h-1][b+w-1][i]-col[a-1][b+w-1][i]);
                }
            }else{
                a++;
                if(a>n-h+1)break;
                for(int i=1;i<=20;i++){
                    rem(i,row[a-1][b+w-1][i]-row[a-1][b-1][i]);
                }
                for(int i=1;i<=20;i++){
                    add(i,row[a+h-1][b+w-1][i]-row[a+h-1][b-1][i]);
                }
                pos=1;
            }
        }else{
            if(b>0){
                b--;
                for(int i=1;i<=20;i++){
                    rem(i,col[a+h-1][b+w][i]-col[a-1][b+w][i]);
                }
                for(int i=1;i<=20;i++){
                    add(i,col[a+h-1][b][i]-col[a-1][b][i]);
                }
            }else{
                a++;
                if(a>n-h+1)break;
                for(int i=1;i<=20;i++){
                    rem(i,row[a-1][b+w-1][i]-row[a-1][b-1][i]);
                }
                for(int i=1;i<=20;i++){
                    add(i,row[a+h-1][b+w-1][i]-row[a+h-1][b-1][i]);
                }
                pos=0;
            }
        }
        ans=max(ans,curr);
    }

    cout<<ans<<"\n";

    return 0;
}