#include <iostream>
#include "shoes.h"
const int maxn = 5000 + 10;

std::vector < int > st, curr;
std::vector < std::pair < int, int > > ans;

bool check(int l, int r, int val)
{
    curr.clear();
    curr.push_back(val);
    for (int i = l ; i <= r ; ++i) curr.push_back(st[i]);
    return pairInSet(curr);
}

void binary(int x)
{
    int l = 0, r = st.size(), mid;
    while (l < r - 1)
    {
        mid = (l+r)/2;
        if (!check(l, mid, x)) l = mid;
        else r = mid;
    }

    if (check(l, l, x)) 
    {
        ans.push_back({x, st[l]});
        std::swap(st[l], st.back());
        st.pop_back();
    }
    else
    {
        ans.push_back({x, st[r]});
        std::swap(st[r], st.back());
        st.pop_back();
    }
}

std::vector < std::pair < int, int > > guessPairs(int n)
{
    st.clear();
    ans.clear();

    for (int i = 1 ; i <= 2*n ; ++i)
    {
        // std::cout << "st:\n";
        // for (int i : st) std::cout << i << ' ';
        // std::cout << '\n';
        // std::cout << "i: " << i << ' ' << st.size() << ' ' << (st.empty() ? -1 : check(0, st.size()-1, i)) << '\n'; 
        if (st.empty()) st.push_back(i);
        else
        {
            if (!check(0, st.size()-1, i)) st.push_back(i);
            else binary(i);
        }
    }

    return ans;
} 