#include <iostream>
#include <algorithm>
#include <vector>
#define int long long

typedef long long llong;
const int maxn = 3000 + 10;
const int inf = 2e9;

int n, m, h, w;
char t[maxn][maxn];
int a[maxn][maxn];


void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            a[i][j] = a[i][j-1] + a[i-1][j] - a[i-1][j-1] + (t[i][j] == 'x');
        }
    }

    int ans = 0;
    for (int i = h ; i <= n ; ++i)
    {
        for (int j = w ; j <= m ; ++j)
        {
            ans = std::max(ans, a[i][j] - a[i-h][j] - a[i][j-w] + a[i-h][j-w]);
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> m >> h >> w;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}