#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 3010;
int n, m, h, w, used[maxn][maxn], sum[maxn * maxn];
char c[maxn][maxn];
pair < int, int > nb[4] = {{0, 1}, {1, 0}, {-1, 0}, {0, -1}};

void bfs(int x, int y, int cnt)
{
    used[x][y] =  cnt;
    queue < pair < int, int > > q;
    q.push({x, y});
    while(!q.empty())
    {
        pair < int, int > cur = q.front();
        q.pop();
        for (int i = 0; i < 4; i ++)
        {
            pair < int, int > neib = cur;
            neib.first += nb[i].first;
            neib.second += nb[i].second;

            if (!used[neib.first][neib.second] && c[neib.first][neib.second] == 'x')
            {
                q.push(neib);
                used[neib.first][neib.second] = cnt;
            }
        }
    }
}
void solve()
{
    cin >> n >> m >> h >> w;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            cin >> c[i][j];

    for (int j = 0; j <= m + 1; j ++)
        c[0][j] = c[n + 1][j] = '.';
    for (int i = 0; i <= n + 1; i ++)
        c[i][0] = c[i][m + 1] = '.';

    int cnt = 0;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            if (c[i][j] == 'x' && !used[i][j])
                cnt ++, bfs(i, j, cnt);
        }

    sum[0] = 1;
    int act = 0;
    for (int i = 1; i <= h; i ++)
        for (int j = 1; j <= w; j ++)
        {
            sum[used[i][j]] ++;
            if (sum[used[i][j]] == 1)
                act ++;
        }

    /**for (int i = 1; i <= n; i ++, cout << endl)
        for (int j = 1; j <= m; j ++)
        cout << used[i][j] << " ";*/


    int ans = act;

    int x = 1, y = 1, pos = 1;
    while(true)
    {
        /**cout << x << " " << y << " " << act << endl;
        for (int i = 1; i <= cnt; i ++)
            cout << sum[i] << " ";
        cout << endl;*/
        if (y + w > m && pos == 1)
        {
            if (x + h > n)
                break;

            for (int j = y; j <= m; j ++)
            {
                sum[used[x][j]] --;
                if (sum[used[x][j]] == 0)
                    act --;
                sum[used[x + h][j]] ++;
                if (sum[used[x + h][j]] == 1)
                    act ++;
            }
            ans = max(ans, act);
            x ++;
            pos = -1;
            continue;
        }

        if (y == 1 && pos == -1)
        {
            if (x + h > n)
                break;

            for (int j = 1; j <= w; j ++)
            {
                sum[used[x][j]] --;
                if (sum[used[x][j]] == 0)
                    act --;
                sum[used[x + h][j]] ++;
                if (sum[used[x + h][j]] == 1)
                    act ++;
            }

            ans = max(ans, act);
            x ++;
            pos = 1;
            continue;
        }

        if (pos == 1)
        {
            for (int i = x; i < x + h; i ++)
            {
                sum[used[i][y]] --;
                if (sum[used[i][y]] == 0)
                    act --;
                sum[used[i][y + w]] ++;
                if (sum[used[i][y + w]] == 1)
                    act ++;
            }

            ans = max(act, ans);
            y ++;
        }
        else
        {
            for (int i = x; i < x + h; i ++)
            {
                sum[used[i][y - 1]] ++;
                if (sum[used[i][y - 1]] == 1)
                    act ++;
                sum[used[i][y + w - 1]] --;
                if (sum[used[i][y + w - 1]] == 0)
                    act --;
            }

            ans = max(act, ans);
            y --;
        }
    }

    cout << ans << endl;



}

int main()
{
    solve();
    return 0;
}
