#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
const int maxn = 3003;
struct cell
{
    int x;
    int y;
    cell(){};
    cell( int x1, int y1 )
    {
        x = x1;
        y = y1;
    }
    cell add( cell c )
    {
        cell ans;
        ans.x = x + c.x;
        ans.y = y + c.y;
        return ans;
    }
};
int n,m,h,w;
int a[maxn][maxn];
cell next_cell[4]{{-1,0},{0,1},{1,0},{0,-1}};
int t_idx = 2;
int used[maxn*maxn];
void read()
{
    cin >> n >> m >> h >> w;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            char c;
            cin >> c;
            if( c == 'x' ) a[i][j] = 1;
            else a[i][j] = 0;
        }
    }
}
void dfs( cell w )
{
    a[w.x][w.y] = t_idx;
    for( int i = 0; i < 4; i ++ )
    {
        cell nb = w.add(next_cell[i]);
        if( a[nb.x][nb.y] == 1 )
        {
            dfs(nb);
        }
    }
}
void fill_a()
{
    for( int i = 1; i <= n; i ++)
    {
        for( int j = 1; j <= m; j++ )
        {
            if( a[i][j] == 1 )
            {
                cell tc(i,j);
                dfs(tc);
                t_idx += 1;
            }
        }
    }
}
int check( int k, int l, int p, int q )
{
    int cnt = 0;
    for( int i = k; i <= p; i ++ )
    {
        for( int j = l; j <= q; j ++ )
        {
            if( a[i][j] == 0 ) continue;
            if( used[a[i][j]] == 0 )
            {
                cnt += 1;
                used[a[i][j]] = 1;
            }
        }
    }
    memset(used,0,sizeof(used));
    return cnt;
}
void solve()
{
    int ans = 0;
    for( int i = 1; i <= n; i ++ )
    {
        int p = i + h - 1;
        if( p > n ) break;
        for( int j = 1; j <= m; j ++ )
        {
            int q = j + w - 1;
            if( q > m ) break;
            int tans = check(i,j,p,q);
            ans = max(ans,tans);
        }
    }
    cout << ans << endl;
}
int main()
{
    read();
    fill_a();
    solve();
    return 0;
}
