#include <bits/stdc++.h>
#define endl '\n'
#pragma optimize GCC("O3")
using namespace std;

const int maxn = 3e5+2, maxd = 5e7+57;
int n, len;
struct point
{
    int x;
    int y;
};
struct rect
{
    int x1, y1;
    int x2, y2;
    int x3, y3;
    int x4, y4;
    bool active = true;
};
point a[maxn];
rect r[maxd];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i].x >> a[i].y ;
    }
}

void init()
{
    int i, j;
    point p1, p2;
    long long int minx, maxx, miny, maxy;
    for (i=1; i<n; ++i)
    {
        p1.x = a[i].x;
        p1.y = a[i].y;
        for (j=i+1; j<=n; ++j)
        {
            p2.x = a[j].x;
            p2.y = a[j].y;
            minx = (p1.x < p2.x) ? p1.x : p2.x;
            maxx = p1.x + p2.x - minx;
            miny = (p1.y < p2.y) ? p1.y : p2.y;
            maxy = p1.y + p2.y - miny;

            ++ len;
            r[len].x1 = minx;
            r[len].y1 = miny;
            r[len].x2 = minx;
            r[len].y2 = maxy;
            r[len].x3 = maxx;
            r[len].y3 = maxy;
            r[len].x4 = maxx;
            r[len].y4 = miny;
        }
    }
}

bool cmp(rect r1, rect r2)
{
    if (r1.x1 < r2.x1) return true;
    if (r1.x1 > r2.x1) return false;
    if (r1.y1 < r2.y1) return true;
    if (r1.y1 > r2.y1) return false;
    if (r1.x2 < r2.x2) return true;
    if (r1.x2 > r2.x2) return false;
    if (r1.y2 < r2.y2) return true;
    if (r1.y2 > r2.y2) return false;
}

bool rect_in_another_rect(rect r1, rect r2)
{
    return (r1.x1>=r2.x1 && r1.x3<=r2.x3 && r1.y1>=r2.y1 && r1.y2<=r2.y2);
}

void solve()
{
    sort(r+1, r+len+1, cmp);
    long long int ans = (n*(n-1))/2;
    int i, j;
    for (i=1; i<=n; ++i)
    {
        //cout << i << ": " ;
        j = i-1;
        while (j>0 && (r[j].active == false || rect_in_another_rect(r[j], r[i])))
        {
            //cout << j << endl;
            //if (r[j].active)
            //{

                r[j].active = false;
            //}
            -- ans;
            -- j;
        }
    }
    cout << ans/2 << endl;
}

int main()
{
    read();
    init();
    solve();
    return 0;
}