#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3004;
int n, m, w, h, p = 0, used[maxn][maxn], ans;
bool a[maxn][maxn], pl[maxn*maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> h >> w ;
    int i, j;
    char c;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> c;
            if (c == 'x') a[i][j] = 1;
        }
    }
}

void DFS(int x, int y)
{
    used[x][y] = p;
    if (y<m && !used[x][y+1] && a[x][y+1]) DFS(x, y+1);
    if (y>1 && !used[x][y-1] && a[x][y-1]) DFS(x, y-1);
    if (x<n && !used[x+1][y] && a[x+1][y]) DFS(x+1, y);
    if (x>1 && !used[x-1][y] && a[x-1][y]) DFS(x-1, y);
}

void init()
{
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            if (a[i][j] && !used[i][j])
            {
                ++ p;
                DFS(i, j);
            }
        }
    }

    /*for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cout << used[i][j] << " " ;
        }
        cout << endl;
    }*/
}

void solve()
{
    int i, j, x, y, t;
    for (i=1; i<=n-h+1; ++i)
    {
        for (j=1; j<=m-w+1; ++j)
        {
            t = 0;
            memset(pl, 0, sizeof(pl));
            for (x=i; x<i+h; ++x)
            {
                for (y=j; y<j+w; ++y)
                {
                    if (used[x][y])
                    {
                        t += (1-pl[used[x][y]]);
                        pl[used[x][y]] = 1;
                    }
                }
            }
            if (t > ans)
            {
                ans = t;
                if (ans == p) return;
            }
        }
    }
}

int main()
{
    read();
    init();
    solve();
    cout << ans << endl;
    return 0;
}