#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3004;
int n, m, w, h, p = 0, used[maxn][maxn], ans, pl[maxn*maxn];
bool a[maxn][maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> h >> w ;
    int i, j;
    char c;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> c;
            if (c == 'x')
                a[i][j] = 1;
        }
    }
}

void DFS(int x, int y)
{
    used[x][y] = p;
    if (y<m && !used[x][y+1] && a[x][y+1])
        DFS(x, y+1);
    if (y>1 && !used[x][y-1] && a[x][y-1])
        DFS(x, y-1);
    if (x<n && !used[x+1][y] && a[x+1][y])
        DFS(x+1, y);
    if (x>1 && !used[x-1][y] && a[x-1][y])
        DFS(x-1, y);
}

void init()
{
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            if (a[i][j] && !used[i][j])
            {
                ++ p;
                DFS(i, j);
            }
        }
    }

    /*for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cout << used[i][j] << " " ;
        }
        cout << endl;
    }*/
}

/*void solve()
{
    int i, j, x, y, t;
    for (i=1; i<=n-h+1; ++i)
    {
        for (j=1; j<=m-w+1; ++j)
        {
            t = 0;
            memset(pl, 0, sizeof(pl));
            for (x=i; x<i+h; ++x)
            {
                for (y=j; y<j+w; ++y)
                {
                    if (used[x][y])
                    {
                        t += (1-pl[used[x][y]]);
                        pl[used[x][y]] = 1;
                    }
                }
            }
            if (t > ans)
            {
                ans = t;
                if (ans == p) return;
            }
        }
    }
}*/

void solve(int&bonus)
{
    int i, j, t = 0;
    for (i=1+bonus; i<=h+bonus; ++i)
    {
        //cout << i << ": " ;
        for (j=1; j<=w; ++j)
        {
            //cout << j << " " ;
            if (used[i][j])
            {
                t += (pl[used[i][j]] == 0 ? 1 : 0);
                ++ pl[used[i][j]];
            }
        }
        //cout << endl;
    }
    if (t > ans)
    {
        ans = t;
        if (ans == p)
        {
            cout << ans << endl;
            exit(0);
        }
    }

    int l;
    for (l=1; l<m-w+1; ++l)
    {
        //cout << l << ": " ;
        for (i=1+bonus; i<=h+bonus; ++i)
        {
            //cout << i << " " ;
            if (used[i][l])
            {
                --pl[used[i][l]];
                if (pl[used[i][l]] == 0) -- t;
            }
            if (used[i][l+w])
            {
                t += (pl[used[i][l+w]] == 0 ? 1 : 0);
                ++ pl[used[i][l+w]];
            }
        }
        //cout << endl;
        if (t > ans)
        {
            ans = t;
            if (ans == p)
            {
                cout << ans << endl;
                exit(0);
            }
        }
    }
}

void fun()
{
    int bonus;
    for (bonus=0; bonus<=n-h; ++bonus)
    {
        memset(pl, 0, sizeof(pl));
        solve(bonus);
    }
    cout << ans << endl;
}

int main()
{
    read();
    init();
    fun();
    return 0;
}