#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 3001;

int n,m,w,h;
char mat[MAXN][MAXN];
int a[MAXN][MAXN];
bool f[MAXN*MAXN/2];
vector<pair<int,int> > ep;

void init()
{
	scanf("%d%d%d%d",&n,&m,&h,&w);
	for(int i =0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			cin>>mat[i][j];
		}
	}
}

bool XX(int i,int j,int x)
{
	//cout<<i<<" "<<j<<endl;
	
	if(a[i][j]!=0) return false;
	int br=0;
	a[i][j]=x;
	if(i>0&&mat[i-1][j]=='x') XX(i-1,j,x);
	else br++;
	if(i<n-1&&mat[i+1][j]=='x') XX(i+1,j,x);
	else br++;
	if(j>0&&mat[i][j-1]=='x') XX(i,j-1,x);
	else br++;
	if(j<m-1&&mat[i][j+1]=='x') XX(i,j+1,x);
	else br++;
	
	//cout<<i<<" "<<j<<" "<<br<<endl;
	
	/*if(br==2)
	{
		if(!((j==m-1||(j<m-1&&mat[i][j+1]=='x'))&&(j==0||(j>0&&mat[i][j-1]=='x'))||
		(i==0||(i>0&&mat[i-1][j]=='x'))&&(i==n-1||(i<n-1&&mat[i+1][j]=='x'))))
			ep.push_back(make_pair(i,j));
	}
	else */
	if(br>=2)
	{
		ep.push_back(make_pair(i,j));
	}
	
	return true;
}

void transferMat()
{
	int br=1;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			if(mat[i][j]=='x')
			{
				//cout<<"da\n";
				if(XX(i,j,br)) br++;
			}
		}
	}
	
	/*for(int i=0;i<n;i++)
	{
		for(int j=0;j<m;j++)
		{
			cout<<a[i][j]<<" ";
		}
		cout<<endl;
	}*/
}

int VilNum(int x,int y)
{
	//cout<<"checking "<<x<<" "<<y<<endl;
	
	int cnt=0;
	vector<int> now;
	
	for(int i=x;i<min(x+h,n);i++)
	{
		for(int j=y;j<min(y+w,m);j++)
		{
			if(a[i][j]!=0)
			{
				if(!f[a[i][j]])
				{
					cnt++;
					now.push_back(a[i][j]);
					f[a[i][j]]=true;
				}
			}
		}
	}
	
	for(int i=0;i<now.size();i++)
	{
		f[now[i]]=false;
	}
	
	return cnt;
}

bool U(int i,int j)
{
	if(i==0) return false;
	if(a[i-1][j]!=0) return false;
	return true;
}

bool D(int i,int j)
{
	if(i==n-1) return false;
	if(a[i+1][j]!=0) return false;
	return true;
}

bool L(int i,int j)
{
	if(j==0) return false;
	if(a[i][j-1]!=0) return false;
	return true;
}

bool R(int i,int j)
{
	if(i==m-1) return false;
	if(a[i][j+1]!=0) return false;
	return true;
}

int Optimal()
{
	int ans=0;
	
	//cout<<ep.size()<<endl;
	
	for(int i=0;i<ep.size();i++)
	{
		int k;
		//if(U(ep[i].first,ep[i].second)&&R(ep[i].first,ep[i].second))
	//	{
			k=VilNum(max(0,ep[i].first-h),ep[i].second);
			if(k>ans) ans=k;
	//	}
	//	if(U(ep[i].first,ep[i].second)&&L(ep[i].first,ep[i].second))
	//	{
			k=VilNum(max(0,ep[i].first-h),max(0,ep[i].second-w));
			if(k>ans) ans=k;
	//	}
	//	if(D(ep[i].first,ep[i].second)&&R(ep[i].first,ep[i].second))
	//	{
			k=VilNum(ep[i].first,ep[i].second);
			if(k>ans) ans=k;
	//	}
	//	if(D(ep[i].first,ep[i].second)&&L(ep[i].first,ep[i].second))
	//	{
			k=VilNum(ep[i].first,max(0,ep[i].second-w));
			if(k>ans) ans=k;
	//	}
	}
	
	return ans;
}

int main()
{
	init();
	transferMat();
	cout<<Optimal()<<endl;
}
/*
3 3 2 2
x . x
x x .
. . .

10 12 4 5
. x x . . x . . x x x .
. x . . x x . . . x x x
x x x . . x x x x . . .
. . x x . . . . . . x x
x . . x x x x . . . x x
x x . x . . x x . x x .
. x . . x x . x x . x .
. . x . . x x . . x x .
x x x . . . x x x x . .
. x . . x x . . . x . x

3 3 2 2
. . .
. x .
. . .

3 3 2 2
x . x
. x .
x . x

4 4 2 3
. x . .
x x . x
. . x .
. . . .

4 4 1 4
x . . x
x . . x
x . . x
x . . x
*/