#include "shoes.h"
#include <iostream>
#include <vector>
using namespace std;


pair<vector<int>, vector<int>> splitShoes(vector<int> shoes);


vector<pair<int, int>> pairs;


vector<pair<int, int>> guessPairs(int n) {
	vector<int> shoes;
	for(int i = 1; i <= n * 2; ++i)
		shoes.push_back(i);
	
	while(!shoes.empty()) {
		int curr_shoe = shoes[0];
		shoes.erase(shoes.begin() + 0);

		vector<int> curr_shoes(shoes);
		while(curr_shoes.size() > 1) {
			auto split_shoes = splitShoes(curr_shoes);
			split_shoes.first.push_back(curr_shoe);
			if(pairInSet(split_shoes.first)) {
				curr_shoes = split_shoes.first;
				curr_shoes.erase(curr_shoes.begin() + curr_shoes.size() - 1);
			}
			else
				curr_shoes = split_shoes.second;
		}
		pairs.push_back({curr_shoe, curr_shoes[0]});

	}
	
	return pairs;
}


pair<vector<int>, vector<int>> splitShoes(vector<int> shoes) {
	pair<vector<int>, vector<int>> split_shoes;
	int i;
	for(i = 0; i < shoes.size(); ++i) {
		if(i < shoes.size() / 2)
			split_shoes.first.push_back(shoes[i]);
		else
			split_shoes.second.push_back(shoes[i]);
	}
	return split_shoes;
}