#include<bits/stdc++.h>
#define mod 1000000007
#define ll long long
#define ull unsigned long long
#define pb push_back
#define pii pair<int,int>
#define pvv pair<vector<int>,vector<int>>
using namespace std;
vector<std::pair<int, int>> guessPairs(int n);
bool pairInSet(const std::vector<int> &v);

vector<pii> ans;

void print(vector<int> v)
{
    for(int x:v) cerr<<x<<" "; cerr<<endl;
}

vector<int> normalize(vector<int> v)
{
    vector<int> a;
    for(int x:v) if(x) a.pb(x);
    return a;
}

bool query(vector<int> a,vector<int> b)
{
    if(!a.size()||!b.size()) return 0;
    vector<int> c;
    for(int x:a) c.pb(x);
    for(int x:b) c.pb(x);
    //print(c);
    return pairInSet(c);
}

pvv mergev(pvv a,pvv b)
{
    pvv c;
    for(int x : a.first) if(x) c.first.pb(x);
    for(int x : b.first) if(x) c.first.pb(x);
    for(int x : a.second) if(x) c.second.pb(x);
    for(int x : b.second) if(x) c.second.pb(x);
    return c;
}

pvv solve(vector<int> a,vector<int> b)
{
    a=normalize(a);
    b=normalize(b);
    if(!query(a,b)) return {a,b};
    int n=max(a.size(), b.size());
    if(n==1)
    {
        ans.pb({a[0],b[0]});
        return {{},{}};
    }
    int n1=(n+1)>>1;
    vector<int> c,d,e,f;
    for(int i=0;i<n1;i++){c.pb(a[i]); d.pb(b[i]);}
    for(int i=n1;i<n;i++)
    {
        if(i>=a.size())e.pb(0); else e.pb(a[i]);
        if(i>=b.size())f.pb(0); else f.pb(b[i]);
    }
    pvv x=solve(c,d);
    pvv y=solve(e,f);
    return mergev(solve(x.first,y.second),solve(y.first,x.second));
}

vector<pair<int, int>> guessPairs(int n)
{
    vector<int> a,b;
    for(int i=1;i<=n;i++) a.pb(i);
    for(int i=1;i<=n;i++) b.pb(n+i);
    solve(a,b);
    return ans;
}
