#include<bits/stdc++.h>
#define lsb(x) (x)&(-x)
#define fr first
#define sc second
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define ll long long
using namespace std;

const int MAXN = 4e3 + 3;
const int MAXK = 22;

int A[MAXN][MAXN], pref[MAXK][MAXN][MAXN], T = 1;
int ans, n, m, h, w;

int get_sub(int x1, int y1, int x2, int y2, int which){
    return pref[which][x2][y2] - (y1 ? pref[which][x2][y1 - 1] : 0) - (x1 ? pref[which][x1 - 1][y2] : 0) + (x1 && y1 ? pref[which][x1 - 1][y1 - 1] : 0);
}

void rec(int x, int y, int c){
    if(A[x][y] != 0) return;
    if(x < 0 || x >= n || y < 0 || y >= m) return;
    A[x][y] = c;
    rec(x - 1, y, c);
    rec(x + 1, y, c);
    rec(x, y - 1, c);
    rec(x, y + 1, c);
}

int main(){
    cin >> n >> m >> h >> w;
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            char c; cin >> c;
            if(c == '.') A[i][j] = -1;
            else         A[i][j] = 0;
        }
    }
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if(A[i][j] == 0){
                rec(i, j, T ++);
            }
        }
    }
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            pref[A[i][j]][i][j] = 1;
        }
    }
    for(int k = 0; k < 22; k ++){
        for(int i = 0; i < n; i ++){
            int t = 0;
            for(int j = 0; j < m; j ++){
                t += (A[i][j] == k ? 1 : 0);
                pref[k][i][j] = (i ? pref[k][i - 1][j] : 0) + t;
            }
        }
    }
    for(int i = 0; i + h - 1 < n; i ++){
        for(int j = 0; j + w - 1 < m; j ++){
            int curr = 0;
            for(int k = 1; k <= 20; k ++){
                if(get_sub(i, j, i + h - 1, j + w - 1, k)){
                    ++ curr;
                }
            }
            ans = max(curr, ans);
        }
    }
    cout << ans << endl;
}
/**
10 12 4 5
. x x . . x . . x x x .
. x . . x x . . . x x x
x x x . . x x x x . . .
. . x x . . . . . . x x
x . . x x x x . . . x x
x x . x . . x x . x x .
. x . . x x . x x . x .
. . x . . x x . . x x .
x x x . . . x x x x . .
. x . . x x . . . x . x
4
4 4 2 2
. x . x
x . x .
. x . x
x . x .
*/

