#include<iostream>
#include<vector>
#include<cstdio>
#include<cstring>
#include<unordered_set>
using namespace std;
#define MAXN 3000
#define MAXM 3000
#define EMPTY -2
#define NOTSET -1
int n,m,h,w;
char matr[MAXN][MAXM];
int matr2[MAXN][MAXM];
int tribes=1;
void change(int i,int j,int num)
{
    if(i<0||i>=n||j<0||j>=m)return;
    if(matr[i][j]=='.'||matr2[i][j]!=NOTSET)return;
    matr2[i][j]=num;
    change(i-1,j,num);
    change(i+1,j,num);
    change(i,j-1,num);
    change(i,j+1,num);
}
void init()
{
    scanf("%d %d %d %d",&n,&m,&h,&w);
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            cin>>matr[i][j];
    memset(matr2,NOTSET,sizeof(matr2));
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
            if(matr2[i][j]==NOTSET)
                if(matr[i][j]=='x')
                    change(i,j,tribes++);
                else matr2[i][j]=EMPTY;
}
void solve()
{
    int max=0;
    int x,y;
    for(int p=0;p<n-h;p++)
        for(int q=0;q<m-w;q++)
        {
            unordered_set<int> s;
            for(int i=0;i<h;i++)
                for(int j=0;j<w;j++)
                    if(matr2[i+p][j+q]!=EMPTY)
                        s.insert(matr2[i+p][j+q]);
            if(max<s.size())
            {
                max=s.size();
                x=p;
                y=q;
            }
        }
    std::cout<<max<<std::endl;
}
int main()
{
    init();
    solve();
}

/*
10 12 4 5
. x x . . x . . x x x .
. x . . x x . . . x x x
x x x . . x x x x . . .
. . x x . . . . . . x x
x . . x x x x . . . x x
x x . x . . x x . x x .
. x . . x x . x x . x .
. . x . . x x . . x x .
x x x . . . x x x x . .
. x . . x x . . . x . x
*/