#include "shoes.h"
#include<iostream>
using namespace std;

bool pairInSet(const std::vector<int> &v);

bool izpolzvanLiE[10010];

vector<pair<int, int>> guessPairs(int n){

    for(int i = 1; i <= 2*n; i++){
        izpolzvanLiE[i] = false;
    }

    vector<pair<int, int>> otgovor;

    for(int i = 1; i <= n; i++){
        if(izpolzvanLiE[i] == false){
            for(int j = n + 1; j <= 2*n; j++){
                if(j != i && izpolzvanLiE[j] == false){
                    vector<int> teziDve;
                    teziDve.push_back(i);
                    teziDve.push_back(j);

                    if(pairInSet(teziDve) == true){
                        otgovor.push_back({i, j});
                        izpolzvanLiE[i] = true;
                        izpolzvanLiE[j] = true;
                    }
                }
            }
        }
    }

    return otgovor;
}
