#include<iostream>
using namespace std;

long long maxY;
long long maxX;

long long visochina;
long long shirochina;

char pustinq[3010][3010];

long long broiXoveDo[3010][3010];

long long broiCvetove;
long long kakvoImaTam[3010][3010];

void dfsOcvetqvane(long long y, long long x, long long cvqt){
    //cout<<y<<" "<<x<<" "<<pustinq[y][x]<<endl;

    if(pustinq[y][x] == '.' || kakvoImaTam[y][x] != 0){
        return ;
    }

    kakvoImaTam[y][x] = cvqt;

    if(x > 0){
        dfsOcvetqvane(y, x - 1, cvqt);
    }
    if(y > 0){
        dfsOcvetqvane(y - 1, x, cvqt);
    }
    if(x < maxX - 1){
        dfsOcvetqvane(y, x + 1, cvqt);
    }
    if(y < maxY - 1){
        dfsOcvetqvane(y + 1, x, cvqt);
    }
}

bool toziCvqtImameLi[10000];

long long kolkoRazlichni(long long lqvX,long long desenX, long long gorenY, long long dolenY){
    toziCvqtImameLi[0] = true;
    for(long long i = 1; i <= broiCvetove; i++){
        toziCvqtImameLi[i] = false;
    }

    long long broiche = 0;

    for(long long y = dolenY; y <= gorenY; y++){
        for(long long x = lqvX; x <= desenX; x++){
            if(toziCvqtImameLi[kakvoImaTam[y][x]] == false){
                toziCvqtImameLi[kakvoImaTam[y][x]] = true;
                broiche++;
            }
        }
    }

    return broiche++;
}

int main(){

    cin>>maxY>>maxX>>visochina>>shirochina;

    for(long long y = 1; y <= maxY; y++){
        for(long long x = 1; x <= maxX; x++){
            cin>>pustinq[y][x];
        }
    }

    for(long long y = 1; y <= maxY; y++){
        for(long long x = 1; x <= maxX; x++){
            broiXoveDo[y][x] = broiXoveDo[y - 1][x] + broiXoveDo[y][x - 1] - broiXoveDo[y - 1][x - 1];

            if(pustinq[y][x] == 'x'){
                broiXoveDo[y][x]++;
            }
        }
    }

    long long maxPlemena = 0;

    for(long long y = visochina; y <= maxY; y++){
        for(long long x = shirochina; x <= maxX; x++){
            long long tuka = broiXoveDo[y][x] - broiXoveDo[y-visochina-1][x] - broiXoveDo[y][x-shirochina-1] + broiXoveDo[y-visochina-1][x-visochina-1];

            maxPlemena = max(maxPlemena, tuka);
        }
    }


    /*for(long long y = 0; y < maxY; y++){
        for(long long x = 0; x < maxX; x++){
            if(pustinq[y][x] == 'x' && kakvoImaTam[y][x] == 0){
                broiCvetove++;
                dfsOcvetqvane(y, x, broiCvetove);
            }
        }
    }

    long long maxPlemena = 0;

    for(long long y = 0; y < maxY; y++){
        for(long long x = 0; x < maxX; x++){
            long long tuka = kolkoRazlichni(x, x + shirochina - 1, y + visochina - 1, y);

            maxPlemena = max(maxPlemena, tuka);
        }
    }*/

    cout<<maxPlemena<<endl;

    return 0;
}
