#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define endl "\n"
using namespace std;

const ll maxn=3*1e3+1;
ll n,m,h,w,i,j,komp[maxn][maxn],ans,maxans;
bool grid[maxn][maxn],used[maxn][maxn];
vector<ll> tribes;

void dfs(ll x, ll y, ll k){
    komp[x][y]=k;
    used[x][y]=true;
    if(x>0){
        if(!used[x-1][y] and grid[x-1][y]){
            dfs(x-1,y,k);
        }
    }
    if(y>0){
        if(!used[x][y-1] and grid[x][y-1]){
            dfs(x,y-1,k);
        }
    }
    if(x<n-1){
        if(!used[x+1][y] and grid[x+1][y]){
            dfs(x+1,y,k);
        }
    }
    if(y<m-1){
        if(!used[x][y+1] and grid[x][y+1]){
            dfs(x,y+1,k);
        }
    }
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    cin >> n >> m >> h >> w;
    char t;
    for(i=0;i<n;i++){
        for(j=0;j<m;j++){
            cin >> t;
            if(t=='x'){
                grid[i][j]=1;
            }
        }
    }
    ll num=1;
    for(i=0;i<n;i++){
        for(j=0;j<m;j++){
            if(!used[i][j] and grid[i][j]){
                dfs(i,j,num);
                num++;
            }
        }
    }
    bool dali;
    /*for(i=0;i<n;i++){
        for(j=0;j<m;j++){
            cout << komp[i][j] << " ";
        }
        cout << endl;
    }*/
    for(i=0;i<=n-h;i++){
        for(j=0;j<=m-w;j++){
            ans=0;
            for(ll x=i;x<i+h;x++){
                for(ll y=j;y<j+w;y++){
                    /*if(i==0 and j==0){
                        cout << x << " x y " << y << " " << h << " |" << w << endl;
                    }*/
                    if(grid[x][y]){
                        dali=true;
                        for(ll z=0;z<tribes.size();z++){
                            if(tribes[z]==komp[x][y]){
                                dali=false;
                                break;
                            }
                        }
                        if(dali){
                            tribes.push_back(komp[x][y]);
                            ans++;
                        }
                    }
                }
            }
            if(maxans<ans){
                maxans=ans;
                /*cout << i << " i j " << j << " " << ans <<endl;
                for(ll z=0;z<tribes.size();z++){
                    cout << tribes[z] << endl;
                }*/
            }
            tribes.clear();
        }
    }
    cout << maxans << endl;
return 0;
}
