#include<bits/stdc++.h>
#define enbdl '\n'
using namespace std;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m, h, w;
const int maxn=3072;
char a[maxn][maxn];

struct cell
{
    int x, y;

    bool is_valid()
    {
        if(x>=0 && x<n && y>=0 && y<m) return true;
        else return false;
    }

    cell add(cell c)
    {
        cell res;
        res.x=x+c.x;
        res.y=y+c.y;
        return res;
    }
};

cell nb[4] = {{0, 1}, {1, 0}, {-1, 0}, {0, -1}};
int used[maxn][maxn];
int br=0;

void DFS(cell v, int cnt)
{
    used[v.x][v.y]=cnt;
    cell nbr;
    for(int i=0; i<4; ++i)
    {
        nbr=v.add(nb[i]);
        if(used[nbr.x][nbr.y]==0 && nbr.is_valid() && a[nbr.x][nbr.y]=='x')
        {
            DFS(nbr, cnt);
        }
    }
}

int ans=0, ans2=0;
int used2[maxn];

void read()
{
    cin>>n>>m>>h>>w;
    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            cin>>a[i][j];
        }
    }

    for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            if(a[i][j]=='x' && used[i][j]==0)
            {
                cell start;
                start.x=i;
                start.y=j;
                DFS(start, ++br);
            }
        }
    }

    for(int i=0; i<=n-h; ++i)
    {
        for(int j=0; j<=m-w; ++j)
        {
            ans=0;
            for(int k=i; k < i+h; ++k)
            {
                for(int g=j; g < j+w; ++g)
                {
                    if(used[k][g]!=0 && !used2[used[k][g]])
                    {

                        used2[used[k][g]]=1;
                        ans++;
                    }
                }
            }
            memset(used2, 0, sizeof(used2));
            if(ans>=ans2)
            {
                ans2=ans;
                ans=0;
            }
        }
    }
}

int main()
{
    speed();
    read();
    cout<<ans2<<endl;

    /*for(int i=0; i<n; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            cout<<used[i][j]<<" ";
        }
        cout<<endl;
    }*/
    return 0;
}
