#include <iostream>
#include <utility>
#define endl '\n'
using namespace std;

const int MAXN = 3000;

int a[MAXN + 5][MAXN + 5];
int dp[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, h, w;
    cin >> n >> m >> h >> w;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char c;
            cin >> c;

            if (c == 'x') a[i][j] = 1;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            dp[i][j] = dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1] + a[i][j];
        }
    }
    
    int ans = 0;
    for (int i = 1; i <= n - h + 1; ++ i)
    {
        for (int j = 1; j <= m - w + 1; ++ j)
        {
            ans = max(ans, dp[i + h - 1][j + w - 1] - dp[i - 1][j + w - 1] - dp[i + h - 1][j - 1] + dp[i - 1][j - 1]);
        }
    }

    cout << ans << endl;

    return 0;
}
