#include <bits/stdc++.h>
using namespace std;

const int maxn = 702;
int n, m, h, w;
int a [maxn][maxn];
int cnt;
bool in [maxn * maxn];
int ans;

void bfs (int i, int j){

    cnt ++;
    queue <pair <int, int> > q;
    q.push ({i, j});
    while (!q.empty ()){
        auto p = q.front ();
        q.pop ();
        i = p.first;
        j = p.second;
        if (i < 0 || i == n || j < 0 || j == m || a [i][j] != -1) continue;
        a [i][j] = cnt;
        q.push ({i, j - 1});
        q.push ({i, j + 1});
        q.push ({i - 1, j});
        q.push ({i + 1, j});
    }

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> h >> w;
    for (int i = 0; i < n; i ++){
        for (int j = 0; j < m; j ++){
            char ch;
            cin >> ch;
            if (ch == 'x') a [i][j] = -1;
        }
    }
    for (int i = 0; i < n; i ++){
        for (int j = 0; j < m; j ++){
            if (a [i][j] == -1) bfs (i, j);
        }
    }

    for (int i = h - 1; i < n; i ++){
        for (int j = w - 1; j < m; j ++){
            for (int ii = 0; ii < h; ii ++){
                for (int jj = 0; jj < w; jj ++){
                    in [a [i - ii][j - jj]] = 1;
                }
            }
            int curr = 0;
            for (int x = 1; x <= cnt; x ++){
                curr += in [x];
                in [x] = 0;
            }
            ans = max (ans, curr);
        }
    }

    cout << ans << '\n';

}