#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 3e5 + 3;
const int inf = 1e9 + 3;

int n;
pair <int, int> pt[maxn];
void read() {
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> pt[i].first >> pt[i].second;
}

bool cmp1(pair <int, int> a, pair <int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;

    return a.second < b.second;
}

bool cmp2(pair <int, int> a, pair <int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;

    return a.second > b.second;
}

int tr[maxn * 4];
void update(int v, int l, int r, int pos, int val) {
    if (l == r) {
        tr[v] = min(tr[v], val);

        return;
    }

    int mid = (l + r) / 2;
    if (pos <= mid)
        update(v * 2, l, mid, pos, val);

    else
        update(v * 2 + 1, mid + 1, r, pos, val);

    tr[v] = min(tr[v * 2], tr[v * 2 + 1]);
}

int find_next(int v, int l, int r, int pos, int val) {
    if (r <= pos)
    return -1;

    if (tr[v] >= val)
        return -1;

    if (l == r)
        return l;

    int mid = (l + r) / 2;
    int first = find_next(v * 2, l, mid, pos, val);
    if (first != -1)
        return first;

    return find_next(v * 2 + 1, mid + 1, r, pos, val);
}

void solve() {
    sort (pt + 1, pt + n + 1, cmp1);
    vector <pair <int, int> > v(n+1);
    for (int i = 1; i <= n; i++)
        v[i] = make_pair(pt[i].second, i);

    sort (v.begin(), v.end());
    reverse(v.begin(), v.end());

    for (int i = 1; i <= 4 * n; i++)
        tr[i] = inf;

        return;

    set <int> s;
    long long ans = 0;
    for (auto i: v) {
        update(1, 1, n, i.second, i.first);
        auto it = s.insert(i.second).first;
        if (next(it) == s.end())
            continue;

        int pos = *next(it);
        ans++;

        for (;;) {
            int nxt = find_next(1, 1, n, pos, pt[pos].second);
            if (nxt == -1)
                break;

            ans++;
            pos = nxt;
        }
    }

    /*
    sort (pt + 1, pt + n + 1, cmp2);
    v.clear();
    for (int i = 1; i <= n; i++)
        v[pt[i].second].push_back(i);

    for (int i = 1; i <= 4 * n; i++)
        tr[i] = -inf;

    s.clear();

    for (auto it: v) {
        for (auto i: it.second) {
            s.insert(i);
            update(1, 1, n, i, it.first, true);
        }

        for (auto i: it.second) {
            auto it1 = s.find(i);
            if (next(it1) == s.end())
                continue;

            int pos = *next(it1);
            ans++;

            for (;;) {
                int nxt = find_next(1, 1, n, pos, pt[pos].second, true);
                if (nxt == -1)
                    break;

                ans++;
                pos = nxt;
            }
        }
    }
    */


    /*
    map <int, int> mp;
    for (int i = 1; i <= n; i++)
        mp[pt[i].first]++;

    for (auto it: mp)
        ans -= it.second - 1;

    mp.clear();
    for (int i = 1; i <= n; i++)
        mp[pt[i].second]++;

    for (auto it: mp)
        ans -= it.second - 1;
        */

    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
