#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 3e5 + 3;
const int inf = 1e9 + 3;
const int bucket_sz = 1000;

int n;
pair <int, int> pt[maxn];
void read() {
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> pt[i].first >> pt[i].second;
}

bool cmp1(pair <int, int> a, pair <int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;

    return a.second < b.second;
}

bool cmp2(pair <int, int> a, pair <int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;

    return a.second > b.second;
}

int lst[maxn], cnt[maxn];
bool is[maxn];
vector <pair <int, int> > vec[bucket_sz];

void update1(int pos) {
    int idx = (pos - 1) / bucket_sz;
    int first = idx * bucket_sz + 1, last = min(n, (idx + 1) * bucket_sz);
    is[pos] = true;

    stack <int> st;
    for (int i = last; i >= first; i--)
    if (is[i]) {
        while (!st.empty() && pt[i].second <= pt[st.top()].second)
        st.pop();

        if (st.empty())
            lst[i] = i, cnt[i] = 1;

        else
            lst[i] = lst[st.top()], cnt[i] = cnt[st.top()] + 1;

        st.push(i);
    }

    vec[idx].clear();
    for (int i = first; i <= last; i++)
        if (is[i])
        if (vec[idx].empty() || pt[i].second < vec[idx].back().first)
        vec[idx].push_back(make_pair(pt[i].second, i));
}

int get1(int pos) {
    int idx = (pos - 1) / bucket_sz;
    int ans = 0;
    ans += cnt[pos];
    pos = lst[pos];

    for (int i = idx + 1; i <= (n - 1) / bucket_sz; i++) {
        if (vec[i].empty() || vec[i].back().first >= pt[pos].second)
            continue;

        int low = 0, high = (int)vec[i].size() - 1;
        while (low < high) {
            int mid = (low + high) / 2;
            if (vec[i][mid].first < pt[pos].second)
                high = mid;

            else
                low = mid + 1;
        }

        ans += cnt[vec[i][low].second];
        pos = lst[vec[i][low].second];
    }

    return ans;
}

void update2(int pos) {
    int idx = (pos - 1) / bucket_sz;
    int first = idx * bucket_sz + 1, last = min(n, (idx + 1) * bucket_sz);
    is[pos] = true;

    stack <int> st;
    for (int i = last; i >= first; i--)
    if (is[i]) {
        while (!st.empty() && pt[i].second >= pt[st.top()].second)
        st.pop();

        if (st.empty())
            lst[i] = i, cnt[i] = 1;

        else
            lst[i] = lst[st.top()], cnt[i] = cnt[st.top()] + 1;

        st.push(i);
    }

    vec[idx].clear();
    for (int i = first; i <= last; i++)
        if (is[i])
        if (vec[idx].empty() || pt[i].second > vec[idx].back().first)
        vec[idx].push_back(make_pair(pt[i].second, i));
}

int get2(int pos) {
    int idx = (pos - 1) / bucket_sz;
    int ans = 0;
    ans += cnt[pos];
    pos = lst[pos];

    for (int i = idx + 1; i <= (n - 1) / bucket_sz; i++) {
        if (vec[i].empty() || vec[i].back().first <= pt[pos].second)
            continue;

        int low = 0, high = (int)vec[i].size() - 1;
        while (low < high) {
            int mid = (low + high) / 2;
            if (vec[i][mid].first > pt[pos].second)
                high = mid;

            else
                low = mid + 1;
        }

        ans += cnt[vec[i][low].second];
        pos = lst[vec[i][low].second];
    }

    return ans;
}

void solve() {
    long long ans = -n;
    sort (pt + 1, pt + n + 1, cmp1);
    for (int i = 1; i <= n; i++)
        if (i == 1 || (pt[i].first != pt[i-1].first))
        ans++;

    vector <pair <int, int> > v(n);
    for (int i = 0; i < n; i++)
        v[i] = make_pair(pt[i+1].second, i+1);

    sort (v.begin(), v.end());
    reverse(v.begin(), v.end());
    ans -= n;
    for (int i = 0; i < n; i++)
        if (i == 0 || (v[i].first != v[i-1].first))
        ans++;

    for (int i = 1; i <= n; i++) {
        is[i] = false;
        cnt[i] = 0;
    }

    for (int i = 0; i <= (n - 1) / bucket_sz; i++)
        vec[i].clear();

    set <int> s;
    for (auto i: v) {
        update1(i.second);
        auto it = s.insert(i.second).first;
        if (next(it) == s.end())
            continue;

        int pos = *next(it);
        ans += get1(pos);
    }

    sort (pt + 1, pt + n + 1, cmp2);
    for (int i = 0; i < n; i++)
        v[i] = make_pair(pt[i+1].second, i+1);

    sort (v.begin(), v.end());
    for (int i = 1; i <= n; i++) {
        is[i] = false;
        cnt[i] = 0;
    }

    for (int i = 0; i <= (n - 1) / bucket_sz; i++)
        vec[i].clear();

    s.clear();
    for (auto i: v) {
        update2(i.second);
        auto it = s.insert(i.second).first;
        if (next(it) == s.end())
            continue;

        int pos = *next(it);
       // cout << pt[i.second].first << " " << pt[i.second].second << " " << get2(pos) << " " << cnt[pos] << endl;
        ans += get2(pos);
    }

    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
