#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 3003;

int n, m, h, w;
char t[maxn][maxn];
void read() {
    cin >> n >> m >> w >> h;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        cin >> t[i][j];
}

int val[maxn][maxn];
void dfs(int x, int y, int idx) {
    if (x > n || x < 1 || y > m || y < 1 || t[x][y] == '.' || val[x][y])
        return;

    val[x][y] = idx;
    dfs(x + 1, y, idx);
    dfs(x - 1, y, idx);
    dfs(x, y + 1, idx);
    dfs(x, y - 1, idx);
}

int cnt[503 * 503];
void solve() {
    int curr_val = 1;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        if (!val[i][j] && t[i][j] == 'x')
        dfs(i, j, curr_val++);

    int ans = 0;
    for (int i = 1; i <= n - w + 1; i++) {
        for (int j = 1; j <= n * m; j++)
        cnt[j] = 0;

        int res = 0;
        for (int p = i; p <= i + w - 1; p++)
        for (int k = 1; k <= h; k++) {
            if (val[p][k]) {
                cnt[val[p][k]]++;
                if (cnt[val[p][k]] == 1)
                    res++;
            }
        }

        ans = max(ans, res);
        for (int k = h + 1; k <= m; k++) {
            for (int p = i; p <= i + w - 1; p++) {
                if (val[p][k-h]) {
                    cnt[val[p][k-h]]--;
                    if (cnt[val[p][k-h]] == 0)
                        res--;
                }

                if (val[p][k]) {
                    cnt[val[p][k]]++;
                    if (cnt[val[p][k]] == 1)
                        res++;
                }
            }

            ans = max(ans, res);
        }
    }

    /*
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)
            cout << val[i][j] << " ";

        cout << endl;
    }
    */

    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
