#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 3003;

int n, m, h, w;
char t[maxn][maxn];
void read() {
    cin >> n >> m >> w >> h;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        cin >> t[i][j];
}

int val[maxn][maxn];
void dfs(int x, int y, int idx) {
    if (x > n || x < 1 || y > m || y < 1 || t[x][y] == '.' || val[x][y])
        return;

    val[x][y] = idx;
    dfs(x + 1, y, idx);
    dfs(x - 1, y, idx);
    dfs(x, y + 1, idx);
    dfs(x, y - 1, idx);
}

int cnt[maxn][maxn][20];
void solve() {
    int curr_val = 1;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        if (!val[i][j] && t[i][j] == 'x')
        dfs(i, j, curr_val++);

    for (int k = 1; k <= 20; k++) {
        for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++) {
            cnt[i][j][k] = cnt[i-1][j][k] + cnt[i][j-1][k] - cnt[i-1][j-1][k];
            if (val[i][j] == k)
                cnt[i][j][k]++;
        }
    }

    int ans = 0;
    for (int i = 1; i <= n - w + 1; i++)
    for (int j = 1; j <= m - h + 1; j++) {
        int x = i + w - 1, y = j + h - 1;
        int res = 0;
        for (int k = 1; k <= 20; k++) {
            int temp = cnt[x][y][k] - cnt[i-1][y][k] - cnt[x][j-1][k] + cnt[i-1][j-1][k];
            if (temp)
                res++;
        }

        ans = max(ans, res);
    }

    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
