#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " = " << x << " ]"

struct debug {
    debug() { cerr << "Debugger start " << endl; }
    ~debug() { cerr << endl << "Debugger end " << endl; }

    template<class T>
    debug& operator <<(const T &x) {
        cerr << x;
        return (*this);
    }
};

template<class T> inline ostream &operator <<(ostream &out, const vector<T> &x) {
    for(auto it : x) {
        out << it << " ";
    }
    return out;
}

template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T, class T2> bool chkmin(T &x, const T2 &y) {
    return (x > y) ? x = y, true : false;
}
template<class T, class T2> bool chkmax(T &x, const T2 &y) {
    return (x < y) ? x = y, true : false;
}
typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 3e3 + 10;
int tab[MAX_N][MAX_N];
string str[MAX_N];
int n, m, h, w;

void dfs(int x, int y, int comp) {
    if(x < 0 || y < 0 || x >= n || y >= m || tab[x][y] != 0) {return;}
    if(str[x][y] == '.') {return;}
    tab[x][y] = comp;
    dfs(x - 1, y, comp);
    dfs(x + 1, y, comp);
    dfs(x, y - 1, comp);
    dfs(x, y + 1, comp);
}

ll total = 0;
ll got[MAX_N * MAX_N];

void add(int x, int val) {
    if(got[x] == 0) {
        total ++;
    }
    got[x] += val;
    if(got[x] == 0) {
        total --;
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> m >> h >> w;
    for(int i = 0; i < n; i ++) {
        str[i].resize(m);
        for(int j = 0; j < m; j ++) {
            cin >> str[i][j];
        }
    }

    int cnt = 1;

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            if(str[i][j] == 'x' && tab[i][j] == 0) {
                dfs(i, j, cnt);
                cnt ++;
            }
        }
    }

    int ret = 0;

    for(int start = 0; start + h <= n; start ++) {
        for(int i = 0; i < h; i ++) {
            for(int j = 0; j < w; j ++) {
                add(tab[start + i][j], 1);
            }
        }

        for(int j = 0; j < m; j ++) {
            chkmax(ret, total);
            for(int i = 0; i < h; i ++) {
                add(tab[start + i][j], -1);
            }
            if(j + w < m) {
                for(int i = 0; i < h; i ++) {
                    add(tab[start + i][j + w], 1);
                }
            }
        }
    }

    cout << ret - 1 << endl;

    return 0;
}


