#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const int inf=1e9+7;

struct point{
    int x;
    int y;
};

int n,ix[MAXN],pos[MAXN],iy[MAXN],curr,last;
long long ans;
int up[MAXN],down[MAXN],cl;
point p[MAXN];

bool cmp(int x,int y){
    return p[x].x<p[y].x;
}

bool cmp2(int x,int y){
    return p[x].y<p[y].y;
}

void rem(int val){
    for(int i=1;i<=n;i++){
        if(up[i]==val)up[i]=-1;
    }
}
void add(int val){
    for(int i=1;i<=n;i++){
        if(ix[i]==val)down[i]=val;
    }
}

int clup(int id){
    int lt=-1,rt=-1,w=pos[id];
    for(int i=w-1;i>=1;i--){
        if(up[i]!=-1 and lt==-1)lt=up[i];
        if(lt!=-1 and up[i]!=-1 and p[up[i]].x==p[lt].x and p[up[i]].y<p[lt].y)lt=up[i];
    }
    for(int i=w+1;i<=n;i++){
        if(up[i]!=-1 and rt==-1)rt=up[i];
        if(rt!=-1 and up[i]!=-1 and p[up[i]].x==p[rt].x and p[up[i]].y<p[rt].y)rt=up[i];
    }
    if(lt==-1)return rt;
    if(rt==-1)return lt;

    if(p[lt].x==p[id].x)return lt;
    if(p[rt].x==p[id].x)return rt;

    if(p[rt].y>p[lt].y)return rt;
    else return lt;
}

int cldown(int id){
    int lt=-1,rt=-1,w=pos[id];
    for(int i=w-1;i>=1;i--){
        if(down[i]!=-1 and lt==-1)lt=down[i];
        if(lt!=-1 and down[i]!=-1 and p[down[i]].x==p[lt].x and p[down[i]].y>p[lt].y)lt=down[i];
    }
    for(int i=w+1;i<=n;i++){
        if(down[i]!=-1 and rt==-1)rt=down[i];
        if(rt!=-1 and down[i]!=-1 and p[down[i]].x==p[rt].x and p[down[i]].y>p[rt].y)rt=down[i];
    }
    if(lt==-1)return rt;
    if(rt==-1)return lt;

    if(p[lt].x==p[id].x)return lt;
    if(p[rt].x==p[id].x)return rt;

    if(p[rt].y<p[lt].y)return rt;
    else return lt;
}

int calcup(int id){
    if(id==-1)return 0;

    int w=pos[id],res=0;
   // cout<<p[id].x<<" "<<p[id].y<<":\n";
    for(int i=w-1;i>=1;i--){
        if(up[i]==-1 or up[i]==curr)continue;
        if(p[up[i]].y<p[up[w]].y){
            if(p[up[i]].x==p[up[w]].x)res--;
            if(p[up[i]].y==p[curr].y)res--;
            res++;w=i;
        }
    }
    w=pos[id];
    for(int i=w+1;i<=n;i++){
        if(up[i]==-1 or up[i]==curr)continue;
        if(p[up[i]].y<p[up[w]].y){
            if(p[up[i]].x==p[up[w]].x)res--;
            if(p[up[i]].y==p[curr].y)res--;
            res++;w=i;
        }
    }
    if(p[id].y!=p[curr].y)res++;
    return res;
}

int calcdown(int id){
    if(id==-1)return 0;
    
    int w=pos[id],res=0;
    for(int i=w-1;i>=1;i--){
        if(down[i]==curr or down[i]==-1)continue;
        if(p[down[i]].y>p[down[w]].y){
            if(p[down[i]].x==p[down[w]].x)res--;
            if(p[down[i]].y==p[curr].y)res--;
            res++;w=i;
        }
    }
    w=pos[id];
    for(int i=w+1;i<=n;i++){
        if(down[i]==curr or down[i]==-1)continue;
        if(p[down[i]].y>p[down[w]].y){
            if(p[down[i]].x==p[down[w]].x)res--;
            if(p[down[i]].y==p[curr].y)res--;
            res++;w=i;
        }
    }
    if(p[id].y!=p[curr].y)res++;
    return res;
}

map<int,int> mp;

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>p[i].x>>p[i].y;
        mp[p[i].y]++;
        ix[i]=i; iy[i]=i;
    }
    for(int i=1;i<=n;i++){
        ans+=2*(mp[p[i].y]-1);
        mp[p[i].y]=1;
    }

    sort(ix+1,ix+n+1,cmp);
    sort(iy+1,iy+n+1,cmp2);

    for(int i=1;i<=n;i++){
        pos[ix[i]]=i;
        up[i]=ix[i];
        down[i]=-1;
    }

    last=1;
    for(int i=1;i<=n;i++){
        curr=iy[i];
        
        if(p[curr].y!=p[iy[i-1]].y){
            for(int f=last;f<=i-1;f++){
                rem(iy[f]);
            }
            for(int f=i;f<=n and p[iy[f]].y==p[curr].y;f++){
                add(iy[f]);
            }
            last=i;
        }

        cl=clup(curr);
        ans+=calcup(cl);
        cl=cldown(curr);
        ans+=calcdown(cl);
    }

    cout<<ans/2<<"\n";

    return 0;
}