#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

struct point{
    int x;
    int y;
};

struct event{
    int pos;
    int from,to;
    int kind;
    int id;
};

vector<event> v;

int n,ans,cnt,pref[4007*4007];
point p[MAXN];
map<int,int> mp;
vector<int> w;

bool cmp(event fr,event sc){
    if(fr.pos!=sc.pos)return fr.pos<sc.pos;
    return fr.kind<sc.kind;   
}

int tree[8*MAXN];

void update(int v,int l,int r,int pos){
    if(l==r){
        tree[v]++;
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos);
        else update(2*v+1,tt+1,r,pos);
        tree[v]=tree[2*v]+tree[2*v+1];
    }
}

int getsum(int v,int l,int r,int ll,int rr){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        return tree[v];
    }else{
        int tt=(l+r)/2;
        return getsum(2*v,l,tt,ll,min(tt,rr)) + getsum(2*v+1,tt+1,r,max(tt+1,ll),rr);
    }
}

int main(){

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>p[i].x>>p[i].y;
        w.push_back(p[i].x);
        w.push_back(p[i].y);
    }
    sort(w.begin(),w.end());cnt=1;
    for(int i=0;i<w.size();i++){
        if(i>0 and w[i]!=w[i-1])cnt++;
        mp[w[i]]=cnt;
    }
    for(int i=1;i<=n;i++){
        p[i].x=mp[p[i].x];
        p[i].y=mp[p[i].y];
    }

    for(int i=1;i<=n;i++){
        for(int f=i+1;f<=n;f++){
            v.push_back({min(p[i].x,p[f].x),min(p[i].y,p[f].y),max(p[i].y,p[f].y),1,i*(n+1)+f});
            v.push_back({max(p[i].x,p[f].x),min(p[i].y,p[f].y),max(p[i].y,p[f].y),3,i*(n+1)+f});
        }
    }
    for(int i=1;i<=n;i++){
        v.push_back({p[i].x,p[i].y,0,2,0});
    }

    sort(v.begin(),v.end(),cmp);

    for(int i=0;i<v.size();i++){
        if(v[i].kind==2){
            update(1,1,cnt,v[i].from);
        }else if(v[i].kind==1){
            pref[v[i].id]=getsum(1,1,cnt,v[i].from,v[i].to);
        }else if(v[i].kind==3){
            pref[v[i].id]=getsum(1,1,cnt,v[i].from,v[i].to)-pref[v[i].id];
            if(pref[v[i].id]==2)ans++;
        }
    }

    cout<<ans<<"\n";

    return 0;
}