#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 3e5+2;
int n;
struct point
{
    int x;
    int y;
};
point a[maxn];
unordered_map <int , int> m_first, m_second;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i].x >> a[i].y ;
    }
}

bool cmp(point a1, point a2)
{
    if (a1.x == a2.x) return (a1.y < a2.y);
    return (a1.x < a2.x);
}

void init()
{
    sort(a+1, a+n+1, cmp);
    int i;
    for (i=1; i<=n; ++i)
    {
        if (!m_first[a[i].x]) m_first[a[i].x] = i;
        m_second[a[i].x] = i;
    }
}

void solve()
{
    int i, j, k, l, r;
    point p1, p2, p;
    bool lamp;
    long long int ans = 0, minx, maxx, miny, maxy;
    for (i=1; i<n; ++i)
    {
        for (j=i+1; j<=n; ++j)
        {
            p1.x = a[i].x;
            p1.y = a[i].y;
            p2.x = a[j].x;
            p2.y = a[j].y;
            minx = (p1.x < p2.x) ? p1.x : p2.x;
            maxx = p1.x + p2.x - minx;
            miny = (p1.y < p2.y) ? p1.y : p2.y;
            maxy = p1.y + p2.y - miny;
            l = m_first[minx];
            r = m_second[maxx];

            lamp = true;
            for (k=l; k<=r; ++k)
            {
                if (k != i && k != j)
                {
                    p.x = a[k].x;
                    p.y = a[k].y;
                    if (p.y >= miny)
                    {
                        if (p.y <= maxy)
                        {
                            lamp = false;
                            break;
                        }
                    }
                }
            }
            if (lamp)
            {
                //cout << i << " " << j << ": " << l << " " << r << endl;
                ++ ans;
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    read();
    init();
    solve();
    return 0;
}